import { defineAsyncComponent as D } from "vue";
import { C as r, E as P, T as I, g as V, h as C, j as R, k as M, l as x, m as H, n as $, o as N, p as F, q as B, r as W, s as Y } from "./forms-zDpk9gMK.es.js";
import { TopPopupWorker as l } from "../popup/worker.js";
import { T as j, _ as q } from "./dialogs.vue_vue_type_script_setup_true_lang-JyillkBh.es.js";
import { isVisible as L } from "../utils/dom.js";
class z {
  static isInited = !1;
  /**
   * Добавить глобальные обработчики
   *
   * Добавляются на страницу один раз и навсегда
   */
  static init() {
    this.isInited || (this.isInited = !0, document.addEventListener("mouseover", (e) => {
      var o;
      !(e.target instanceof HTMLElement) || !((o = e.target.dataset) != null && o.topPopupOpenByHover) || e.target.click();
    }), document.addEventListener("scroll", () => {
      r.state.isMobile || r.state.isMobileUA || l.getAll().forEach((e) => l.close(e));
    }), P.addOnReize((e) => {
      r.state.isMobile && e.topEvent.widthDiff && l.getAll().forEach((o) => l.close(o));
    }), document.addEventListener("click", this.onclick, { capture: !0 }));
  }
  /**
   * Глобальный обработчик кликов
   *
   * Обрабатывает клики на открытие Popup
   */
  static async onclick(e) {
    var n, i, s, a, y;
    if (!(e.target instanceof HTMLElement)) return;
    let o;
    switch (!0) {
      case !!((n = e.target.dataset) != null && n.topPopup):
        o = e.target;
        break;
      case !!((i = e.target.parentElement) != null && i.dataset.topPopup):
        o = e.target.parentElement;
        break;
      case !!((a = (s = e.target.parentElement) == null ? void 0 : s.parentElement) != null && a.dataset.topPopup):
        o = (y = e.target.parentElement) == null ? void 0 : y.parentElement;
        break;
    }
    o && (o.dataset.topPopupDisabled || o.dataset.topPopupOpened || (e.preventDefault(), await l.openByOpener(o)));
  }
}
let T;
const G = {
  mounted: async (t, e) => {
    T || (T = (await import("../utils/dom.js")).storage);
    const o = e.arg, n = e.value;
    T(t, o, n);
  }
};
let g, p = [], w;
const Q = async () => {
  const { isVisible: t } = await import("../utils/dom.js");
  if (p = p.filter(t), !p.length) return;
  p[0].focus(), p = [];
}, U = async (t) => {
  g || (g = await import("../utils/lodash.js")), w || (w = g.debounce(Q, 30)), p.push(t), w();
}, J = {
  mounted: function(t, e) {
    t.__TOP_V_FOCUS_VALUE = e.value ?? !0, (e.value ?? !0) && U(t);
  },
  updated: function(t, e) {
    e.modifiers.onupdate && t.__TOP_V_FOCUS_VALUE !== (e.value ?? !0) && (t.__TOP_V_FOCUS_VALUE = e.value ?? !0, (e.value ?? !0) && U(t));
  }
};
let m, h;
const O = (t) => (typeof t == "boolean" || (t ? t = { ...t } : t = {}, t.behavior ??= "smooth", t.block ??= "nearest", t.inline ??= "nearest"), t);
let f, b;
const K = async () => {
  if (!f) return;
  const t = await _(f);
  t.isVisible && f.scrollIntoView(t.scrollIntoViewOptions);
}, S = async (t) => {
  h || (h = await import("../utils/lodash.js")), b || (b = h.debounce(K, 30)), f = t, b();
}, _ = async (t, e) => {
  m || (m = await import("../utils/dom.js"));
  let o = m.storage(t, "v-top-scrollIntoView");
  return o || (o = {
    isVisible: L(t),
    scrollIntoViewOptions: O(e)
  }, m.storage(t, "v-top-scrollIntoView", o)), o;
}, X = {
  async mounted(t, e) {
    await _(t, e.value), e.modifiers.immediate && S(t);
  },
  async updated(t, e) {
    const o = await _(t, e.value);
    o.scrollIntoViewOptions = O(e.value);
    const n = L(t);
    n && o.isVisible !== n && S(t), o.isVisible = n;
  }
};
let c;
const Z = {
  async mounted(t) {
    c || (c = await import("../utils/scroll.js")), c.connectScrollShadow(t);
  },
  async unmounted(t) {
    c || (c = await import("../utils/scroll.js")), c.unconnectScrollShadow(t);
  }
};
let u;
const tt = {
  mounted(t, e, o) {
    const n = e.value || "top-sticky";
    u = new IntersectionObserver((i) => {
      let s = i[0].intersectionRatio < 1;
      s && e.modifiers.bottom && i[0].intersectionRect.y === 0 && (s = !1), t.classList.toggle(n, s);
    }, {
      threshold: [1]
    }), u.observe(t);
  },
  unmounted(t, e, o) {
    u == null || u.disconnect();
  }
};
let k = !1, d;
const v = /* @__PURE__ */ new Map(), et = (t, e) => {
  const { distance: o, percent: n } = t.directiveSwipUpOptions, i = t.getBoundingClientRect().top, s = e * n / 100 / o, a = (e - i) / s;
  a <= o ? t.style.transform = `translateY(${o - a}px)` : t.style.transform = "translateY(0px)";
}, ot = (t) => {
  let e = window.innerHeight;
  window.addEventListener("scroll", () => {
    v.forEach((o) => et(o, e));
  }, { passive: !0 }), d = new IntersectionObserver((o) => {
    e = window.innerHeight, o.forEach((n) => {
      const i = n.target;
      if (n.intersectionRatio < 0.1 ? v.delete(i) : v.set(i, i), n.intersectionRatio === 0) {
        const { distance: s } = i.directiveSwipUpOptions;
        i.style.transform = `translateY(${s}px)`;
      }
    });
  }, {
    threshold: 0.1
  });
}, nt = {
  mounted(t, e, o) {
    var n, i;
    r.state.isMobileUA || (t.directiveSwipUpOptions = {
      distance: ((n = e.value) == null ? void 0 : n.distance) ?? 100,
      // количество px на которые блок изначально смещен вниз,
      percent: ((i = e.value) == null ? void 0 : i.percent) ?? 30
      // процент высоты экрана поднявшись на который блок закончит подплытие
    }, k || (ot(), k = !0), d.observe(t));
  },
  unmounted(t, e, o) {
    v.delete(t), d == null || d.unobserve(t);
  }
}, E = (t) => {
  var e, o;
  if (!((o = (e = r.$) == null ? void 0 : e.ui) != null && o.tooltip)) {
    console.info("Для работы v-top-tooltip требуется глобальная загрузка jQuery UI Tooltip");
    return;
  }
  return r.$(t);
}, A = (t, e) => {
  var n;
  const o = t.value ?? {};
  return o.content ??= (n = e.props) == null ? void 0 : n.title, o.content = String(o.content).replace(/\r\n|\r|\n/g, "<br>"), o.position ??= {
    my: "bottom-18px",
    at: "top center"
  }, o;
}, it = {
  mounted(t, e, o) {
    var n;
    (n = E(t)) == null || n.tooltip(A(e, o));
  },
  updated(t, e, o, n) {
    var a;
    const i = A(e, o), s = (a = E(t)) == null ? void 0 : a.tooltip("instance");
    s && (s.options = {
      ...s.options,
      ...i
    });
  },
  unmounted(t, e, o) {
    var n;
    (n = E(t)) == null || n.tooltip("destroy");
  }
}, st = D(() => import("./notice-B8hUtbou.es.js"));
window.vd = console.log;
const ut = {
  install: (t, e) => {
    t.config.globalProperties.$core = r, t.config.globalProperties.$vd = console.log;
    for (const o in e)
      r.state[o] = e[o];
    e.widthForMobile && (r.widthForMobile = e.widthForMobile), e.themeName && (r.themeName = e.themeName), r._setState(), e.topPopupOptions && (l.options = e.topPopupOptions), z.init(), j.init(e.topDialogOptions), t.directive("top-data", G), t.directive("top-focus", J), t.directive("top-scroll-into-view", X), t.directive("top-scroll-shadow", Z), t.directive("top-sticky", tt), t.directive("top-swim-up", nt), t.directive("top-tooltip", it), t.component("TopAvatar", I), t.component("TopButton", V), t.component("TopCheckbox", C), t.component("TopControlLabel", R), t.component("TopHint", M), t.component("TopInput", x), t.component("TopInputDate", H), t.component("TopInputRange", $), t.component("TopLoadbar", N), t.component("TopRadio", F), t.component("TopSelect", B), t.component("TopSwitcher", W), t.component("TopTextarea", Y), t.component("TopNotice", st), t.component("TopDialogs", q);
  }
};
export {
  ut as c
};
//# sourceMappingURL=core-CUNwUlL6.es.js.map
