import { Core as P } from "../core/app.js";
import { defineComponent as T, mergeModels as S, useModel as $, computed as h, createElementBlock as i, openBlock as a, normalizeClass as f, createElementVNode as r, createCommentVNode as k, toDisplayString as g, Fragment as w, renderList as H, normalizeStyle as L, unref as F, ref as b, watch as V, onMounted as N, onUnmounted as R, renderSlot as z, createBlock as G, Teleport as O } from "vue";
import { c as X } from "../.chunks/forms-zDpk9gMK.es.js";
import { percentOfNumber as I } from "../utils/number.js";
const E = ["../assets/charts.css"].map((v) => import.meta.resolve(v));
P.insertCSSLinkToPage(E, !0);
const A = 90, D = 10, U = ["data-top-icon"], W = { class: "top-miniChart_chart" }, Y = ["onMouseenter"], j = { class: "top-miniChart_data" }, q = { class: "top-miniChart_dataValue" }, J = ["innerHTML"], K = /* @__PURE__ */ T({
  __name: "miniChart",
  props: /* @__PURE__ */ S({
    title: {},
    gIcon: {},
    color: { default: "blue" },
    dates: {},
    values: {},
    activeDates: {},
    keysForDyn: {},
    dynamic: {},
    isInvert: { type: Boolean },
    numberCols: { default: A },
    additionalHTML: {},
    modelValue: {},
    valueSuffix: {},
    hideChartInMobile: { type: Boolean }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(v) {
    const t = v, d = $(v, "modelValue"), u = (e) => {
      let o = c.value;
      t.isInvert && (e -= 1, o -= 1);
      let n = o > 0 ? Math.round(e / o * (100 - D)) : 0;
      return t.isInvert ? 100 - n : n + D;
    }, C = (e) => t.activeDates.includes(e), c = h(() => Math.max(...t.values)), m = h(() => t.dates.slice().reverse()), y = h(() => t.dates.length ? t.numberCols - t.dates.length : 0), M = () => {
      d.value = null;
    }, s = (e, o, n) => {
      e.target instanceof HTMLElement && (d.value = {
        elCol: e.target,
        date: X(o),
        value: n === null ? "--" : n + (t.valueSuffix ?? "")
      });
    }, l = h(() => {
      let e = t.dynamic;
      if (typeof e > "u") {
        const n = t.values[t.keysForDyn.start];
        e = t.values[t.keysForDyn.end] - n;
      }
      return (e < 0 ? -1 : 1) * I(Math.abs(e));
    }), p = h(() => {
      let e = "stay";
      return t.isInvert ? (l.value > 0 && (e = "down"), l.value < 0 && (e = "up")) : (l.value > 0 && (e = "up"), l.value < 0 && (e = "down")), e;
    });
    return (e, o) => (a(), i("div", {
      class: f({
        "top-miniChart": !0,
        "top-miniChart_hideChartInMobile": e.hideChartInMobile,
        [`top-color_${e.color}`]: !0
      })
    }, [
      r("div", {
        class: "top-miniChart_title top-ellipsis",
        "data-top-icon": e.gIcon
      }, g(e.title), 9, U),
      r("div", W, [
        r("div", {
          class: "top-miniChart_chartGrid",
          onMouseleave: o[1] || (o[1] = (n) => M())
        }, [
          (a(!0), i(w, null, H(m.value, (n, _) => (a(), i("div", {
            class: f({
              "top-miniChart_chartGridCol": !0,
              "top-active": C(n)
            }),
            onMouseenter: (B) => s(B, n, e.values[e.values.length - _ - 1])
          }, [
            r("div", {
              style: L("height:" + u(e.values[e.values.length - _ - 1]) + "%")
            }, null, 4)
          ], 42, Y))), 256)),
          (a(!0), i(w, null, H(y.value, () => (a(), i("div", {
            class: "top-miniChart_chartGridCol top-miniChart_chartGridCol-none",
            onMouseenter: o[0] || (o[0] = (n) => M())
          }, o[2] || (o[2] = [
            r("div", null, null, -1)
          ]), 32))), 256))
        ], 32)
      ]),
      r("div", j, [
        r("span", {
          class: f({
            "top-miniChart_dataDynamic": !0,
            [`top-miniChart_dataDynamic-direction_${p.value}`]: !0
          })
        }, g(Math.abs(l.value) || ""), 3),
        r("span", q, g(F(I)(e.values[e.values.length - 1]) || 0), 1)
      ]),
      e.additionalHTML ? (a(), i("div", {
        key: 0,
        innerHTML: e.additionalHTML
      }, null, 8, J)) : k("", !0)
    ], 2));
  }
}), Q = {
  key: 0,
  class: "top-miniCharts_pages"
}, Z = ["onClick"], x = /* @__PURE__ */ T({
  __name: "miniCharts",
  props: /* @__PURE__ */ S({
    modelValue: {},
    countCharts: {},
    hideChartInMobile: { type: Boolean }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(v) {
    const t = v, d = $(v, "modelValue"), u = b(null);
    let C;
    const c = b(1), m = b(1), y = () => {
      c.value = Math.round(u.value.scrollHeight / u.value.clientHeight);
    };
    V(c, () => {
      c.value < m.value && (m.value = 1);
    }), V(
      () => t.countCharts,
      () => y(),
      { flush: "post" }
    );
    const M = h(() => {
      if (!d.value) return {};
      const s = d.value.elCol.getBoundingClientRect(), l = {
        top: s.bottom + window.scrollY + "px"
      };
      return document.documentElement.clientWidth / 2 > s.right ? l.left = s.right + window.scrollX + 10 + "px" : (l.left = s.left + window.scrollX - 10 + "px", l.transform = "translate(-100%, 0)"), l;
    });
    return N(() => {
      C = new ResizeObserver(() => y()), C.observe(u.value), V(m, () => {
        const p = (u.value.children[0].clientHeight + parseInt(window.getComputedStyle(u.value).getPropertyValue("row-gap"))) * (m.value - 1);
        u.value.scrollTo({ top: p, behavior: "smooth" });
      });
    }), R(() => {
      C.disconnect();
    }), (s, l) => (a(), i("div", {
      class: f(["top-miniCharts", {
        "top-miniCharts": !0,
        scrollable: c.value > 1,
        "top-miniCharts_hideChartInMobile": s.hideChartInMobile
      }]),
      ref_key: "elRef",
      ref: u
    }, [
      z(s.$slots, "default"),
      c.value > 1 ? (a(), i("div", Q, [
        (a(!0), i(w, null, H(c.value, (p) => (a(), i("span", {
          class: f({ "top-active": p === m.value }),
          onClick: (e) => m.value = p
        }, null, 10, Z))), 256))
      ])) : k("", !0),
      (a(), G(O, { to: "body" }, [
        d.value ? (a(), i("div", {
          key: 0,
          class: "top-miniCharts_tooltip",
          style: L(M.value)
        }, [
          r("span", null, g(d.value.date), 1),
          r("span", null, g(d.value.value), 1)
        ], 4)) : k("", !0)
      ]))
    ], 2));
  }
}), ne = K, ae = x;
export {
  ne as TopMiniChart,
  ae as TopMiniCharts
};
//# sourceMappingURL=charts.js.map
