import { PropsCommon } from '../page/types';
import { Component } from 'vue';
export interface Props extends PropsCommon {
    /**
     * Компонент страницы с реализицией TopDialogPage
     */
    component: Component;
    /**
     * Кешировать ли эту страницу
     *
     * По умолчанию: true
     */
    keepAlive?: boolean;
    /**
     * Произвольный набор props, который будет передан в компонент страницы
     */
    props?: Record<string, any>;
}
