import { Size } from '../helpers';
/**
 * Определение параметров
 */
export interface Props {
    color?: Color;
    styling?: Styling;
    size?: Size;
    name?: string;
    title?: string;
    icon?: string;
    icon2?: string;
    /**
     * Ссылка
     *
     * Если указана ссылка, isSubmit не может быть true
     */
    href?: string;
    /**
     * Добавить на кнопку бейдж с числом
     */
    badgeNumber?: number;
    /**
     * Расположить badge после текста
     */
    badgePosAfterText?: boolean;
    disabled?: boolean;
    isSubmit?: boolean;
    isActive?: boolean;
    isProgress?: boolean;
}
/**
 * Определение событий
 */
export interface Emits {
}
export type Color = 'theme' | 'blue' | 'green' | 'orange' | 'red' | 'pink' | 'brand';
export type Styling = '' | 'soft' | 'outline';
export type { Size };
