type ModelValue = boolean | number[] | string[] | Set<number> | Set<string> | undefined;
export interface Props {
    /**
     * Может быть одного из типов:
     * - boolean
     * - number[]
     * - string[]
     * - Set<number>
     * - Set<string>
     *
     * [подробнее](https://vuejs.org/guide/essentials/forms.html#checkbox)
     */
    modelValue: ModelValue;
    name?: string;
    value?: string;
    description?: string;
    disabled?: boolean;
    indeterminate?: boolean;
    isError?: boolean;
}
export {};
