import { Size } from '../helpers';
export interface Props {
    modelValue: string;
    name?: string;
    disabled?: boolean;
    readonly?: boolean;
    modificator?: string;
    size?: Size;
    styling?: Styling;
    isError?: boolean;
    isLoading?: boolean;
    icon?: string;
    icon2?: string;
    addCleaner?: boolean;
    title?: string;
    captionType?: CaptionType;
}
export interface Emits {
    (e: 'update:modelValue', value: string): void;
}
export type Styling = '' | 'light' | 'soft' | 'transparent';
export type CaptionType = '' | 'slide' | 'top';
export type { Size };
