export interface Props {
    /**
     * [подробнее](https://vuejs.org/guide/essentials/forms.html#radio)
     */
    modelValue: number | string | object;
    value: Props['modelValue'];
    name?: string;
    description?: string;
    disabled?: boolean;
    isError?: boolean;
}
export interface Emits {
    (e: 'update:modelValue', value: Props['modelValue']): void;
}
