type ModelValue = boolean | string[] | Set<string>;
export interface Props {
    /**
     * Может быть одного из трех типов:
     * - boolean
     * - string[]
     * - Set
     *
     * [подробнее](https://vuejs.org/guide/essentials/forms.html#checkbox)
     */
    modelValue: ModelValue;
    name?: string;
    value?: string;
    description?: string;
    disabled?: boolean;
    isError?: boolean;
}
export interface Emits {
    (e: 'update:modelValue', value: ModelValue): void;
}
export {};
