export interface Props {
    icon: string;
    /**
     * Стиль оформления
     */
    styling?: 'default' | 'info' | 'warning' | 'negative';
    /**
     * Размер
     */
    size?: 'default' | 's' | 'm' | 'l';
}
export interface Slots {
    /**
     * Текст сообщения
     */
    default(props: {}): any;
    /**
     * Текст справа от сообещния с дополнительной информацией (например, сумма к оплате)
     */
    additional?(props: {}): any;
}
