import { Size } from '../../forms/helpers';
export interface Props {
    modelValue: number | string;
    /**
     * Массив props для вставки radioGroupItem
     */
    radiosProps?: ItemProps[];
    showIndicator?: boolean;
    size?: Size;
    isError?: boolean;
}
export interface Emits {
    (e: 'update:modelValue', value: Props['modelValue']): void;
}
export interface ItemProps {
    value: Props['modelValue'];
    title: string;
    icon?: string;
    disabled?: boolean;
}
export type { Size };
