import { Emits as PopupEmits, Props as PopupProps } from '../popup/popup';
export interface Props extends PopupProps {
    /**
     * Текст кнопки отмены
     */
    cancelText?: string;
    /**
     * Текст кнопки подтверждения
     */
    submitText?: string;
    /**
     * Если true, кнопка подтверждения будет красной
     */
    isWarning?: boolean;
}
export type Emits = PopupEmits & {
    /**
     * Будет вызвано при нажатии кнопок или закрытии окна
     */
    submit: [];
};
