import { TopLibPopup } from '../lib/popup';
import { Props, PopupEvent } from './popup';
import { DefineComponent, ComponentOptionsMixin, PublicProps, ComponentProvideOptions } from 'vue';
declare function __VLS_template(): {
    attrs: Partial<{}>;
    slots: {
        opener?(_: {}): any;
        header?(_: {}): any;
        widget?(_: {}): any;
        content?(_: {}): any;
        contentList?(_: {}): any;
        footer?(_: {}): any;
    };
    refs: {};
    rootEl: any;
};
type __VLS_TemplateResult = ReturnType<typeof __VLS_template>;
declare const __VLS_component: DefineComponent<Props, {
    popup: TopLibPopup | undefined;
}, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    close: (popupEvent: PopupEvent) => any;
    open: (popupEvent: PopupEvent) => any;
    scrollContentList: (e: Event) => any;
}, string, PublicProps, Readonly<Props> & Readonly<{
    onClose?: ((popupEvent: PopupEvent) => any) | undefined;
    onOpen?: ((popupEvent: PopupEvent) => any) | undefined;
    onScrollContentList?: ((e: Event) => any) | undefined;
}>, {
    id: string;
    posBy: "fixed" | "left" | "right";
    pos: "0" | "1" | "2" | "3" | "4";
    notch: boolean;
}, {}, {}, {}, string, ComponentProvideOptions, false, {}, any>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, __VLS_TemplateResult["slots"]>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
