import { Emits as PopupEmits, Props as PopupProps } from '../popup/popup';
export interface Props extends PopupProps {
    /**
     * Текст кнопки подтверждения
     */
    submitText?: string;
    /**
     * Текст кнопки отмены
     */
    cancelText?: string;
    /**
     * Значение, введенное в поле ввода
     */
    defaultValue?: string;
}
export type Emits = PopupEmits & {
    /**
     * Будет вызвано при нажатии кнопки подтверждения
     */
    submit: [value: string];
};
