import { ComponentCustomProps } from 'vue';
import { default as SelectorCompetitors } from './selectorCompetitors/selectorCompetitors.vue';
import { default as SelectorRegion } from './selectorRegion/selectorRegion.vue';
import { default as TagSelector } from './tagSelector/tagSelector.vue';
import { default as TagSelectorPopupOpener } from './tagSelector/popupOpener/popupOpener.vue';
import { default as TagSelectorTagIcon } from './tagSelector/tagIcon/tagIcon.vue';
export declare const TopSelectorCompetitors: typeof SelectorCompetitors & ComponentCustomProps;
export { useItemsFromCompetitors } from './selectorCompetitors/composables';
export { findRegion, genSearcherByKey, dialogSelectorRegions } from './selectorRegion/utils/utils';
export declare const TopSelectorRegion: typeof SelectorRegion & ComponentCustomProps;
export type { Emits as TopTagSelectorEmits, Tag, TagId, TagIdExclude } from './tagSelector/types';
export { genElPopupOpener as genElTopTagSelectorPopupOpener, renderElPopupOpener as renderElTopTagSelectorPopupOpener, } from './tagSelector/utils/el';
export declare const TopTagSelector: typeof TagSelector & ComponentCustomProps;
export declare const TopTagSelectorPopupOpener: typeof TagSelectorPopupOpener & ComponentCustomProps;
export declare const TopTagSelectorTagIcon: typeof TagSelectorTagIcon & ComponentCustomProps;
