import { Region } from '../selectorRegion';
export interface Props {
    /**
     * Список регионов
     */
    regions: Region[];
    /**
     * Выбранные регионы
     */
    regionsIndexes: number[];
    /**
     * Колбэк для emit изменения выбранных регионов
     */
    '@update:regionsIndexes': (regionsIndexes: number[]) => void;
}
/**
 * Регион для шаблона
 */
export type RegionRich = Region & {
    selected: boolean;
    title: string;
    searcherIcon: string;
    langLabel?: string;
    deviceIcon?: string;
    flagLink?: string;
};
