import { Region, SearcherIndexed } from '../selectorRegion';
/**
 * Ключ ПС - для выбора нескольких ПС или регионов
 */
export declare const searhcerCompareKey = -1;
/**
 * Ключ ПС или индекса Региона, используется для ПС или Региона, не настроенных в проекте
 *
 * Также, используется для API с возможностью не указывать регион, см. `props.autoRegion`
 */
export declare const dummyIndex = -2;
/**
 * Регион - без региона
 */
export declare const globalRegionIndex = -1;
export declare const searchersNames: {
    0: string;
    1: string;
    4: string;
    5: string;
    7: string;
    8: string;
    9: string;
    20: string;
    21: string;
};
export declare const regionUndefined: Region;
export declare const searcherUndefined: SearcherIndexed;
export declare const getRegionAuto: () => Region;
export declare const getSearcherAuto: () => SearcherIndexed;
export declare const getRegionGlobal: () => Region;
