import { FiltersAction, Props, Tag } from './types';
import { DefineComponent, ComponentOptionsMixin, PublicProps, ComponentProvideOptions } from 'vue';
type __VLS_Props = Props;
type __VLS_PublicProps = {
    modelValue: Props['modelValue'];
    'tags'?: Tag[];
} & __VLS_Props;
declare const _default: DefineComponent<__VLS_PublicProps, {}, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    selector: (tagsIds: ("1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13" | "14" | "15" | "16" | "17" | "18" | "19" | "20" | "-1" | "-2" | "-3" | "-4" | "-5" | "-6" | "-7" | "-8" | "-9" | "-10" | "-11" | "-12" | "-13" | "-14" | "-15" | "-16" | "-17" | "-18" | "-19" | "-20")[]) => any;
    "update:modelValue": (value: ("1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13" | "14" | "15" | "16" | "17" | "18" | "19" | "20" | "-1" | "-2" | "-3" | "-4" | "-5" | "-6" | "-7" | "-8" | "-9" | "-10" | "-11" | "-12" | "-13" | "-14" | "-15" | "-16" | "-17" | "-18" | "-19" | "-20")[]) => any;
    setter: (event: {
        tagsIds: Tag["id"][];
        targetId?: number | string;
        filters?: [];
        filtersAction?: FiltersAction;
        payload?: Record<string, any>;
    }) => any;
    tagsChanged: (tags: Tag[]) => any;
    "update:tags": (value: Tag[]) => any;
}, string, PublicProps, Readonly<__VLS_PublicProps> & Readonly<{
    onSelector?: ((tagsIds: ("1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13" | "14" | "15" | "16" | "17" | "18" | "19" | "20" | "-1" | "-2" | "-3" | "-4" | "-5" | "-6" | "-7" | "-8" | "-9" | "-10" | "-11" | "-12" | "-13" | "-14" | "-15" | "-16" | "-17" | "-18" | "-19" | "-20")[]) => any) | undefined;
    "onUpdate:modelValue"?: ((value: ("1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13" | "14" | "15" | "16" | "17" | "18" | "19" | "20" | "-1" | "-2" | "-3" | "-4" | "-5" | "-6" | "-7" | "-8" | "-9" | "-10" | "-11" | "-12" | "-13" | "-14" | "-15" | "-16" | "-17" | "-18" | "-19" | "-20")[]) => any) | undefined;
    onSetter?: ((event: {
        tagsIds: Tag["id"][];
        targetId?: number | string;
        filters?: [];
        filtersAction?: FiltersAction;
        payload?: Record<string, any>;
    }) => any) | undefined;
    onTagsChanged?: ((tags: Tag[]) => any) | undefined;
    "onUpdate:tags"?: ((value: Tag[]) => any) | undefined;
}>, {
    tagsMax: number;
    requiredForSetter: boolean;
    emitDelay: number;
}, {}, {}, {}, string, ComponentProvideOptions, false, {}, any>;
export default _default;
