type TopUIEvent = UIEvent & {
    topEvent: {
        widthDiff: number;
        hightDiff: number;
    };
};
/**
 * Добавить обработчик на событие изменения размеров экрана
 * вызов таких обработчиков будет опмизирован и объединен в одно событие
 */
export declare const addOnReize: (listener: (this: HTMLElement, e: TopUIEvent) => void) => void;
/**
 * Удаление обработчика на событие изменений размеров экрана
 */
export declare const removeOnResize: (listener: (this: HTMLElement, e: TopUIEvent) => void) => void;
export {};
