import { DirectiveBinding } from 'vue';
type Binding = DirectiveBinding<boolean, 'onupdate'>;
/**
 * Фокусировка на элементе сразу после его отображения
 */
declare const focus: {
    mounted: (el: HTMLElement, binding: Binding) => void;
    updated: (el: HTMLElement, binding: Binding) => void;
};
export default focus;
