import { Lang } from '../plugins/i18n';
import { default as Core } from '../core/core';
/**
 * Сгенерировать строку с суммой и валютой
 * @param sum - сумма
 * @param lang - язык, берётся из профиля, если не задано
 * @param currency - валюта, берётся из профиля, если не задано
 * @returns строка с языкозависимым представлением числа sum и знаком валюты
 */
export declare const genPrice: (sum: number, lang?: Lang, currency?: typeof Core.state.currency) => string;
