/**
 * Информация о скролле, фичи для скролла
 * @packageDocumentation
 */
/**
 * Добавить классы модификаторов тени в зависимости от скролла элемента
 *
 * @todo Сделать приватной
 */
export declare const genHasScroll: (el: HTMLElement) => void;
/**
 * Добавить отображение тени при появлении скролла у элемента
 *
 * Будут добавлены события для усатновки модификаторов тени в зависимости от скролла элемента
 *
 * Модификаторы:
 * - top-scrollShadow
 * - top-scrollShadow-started
 * - top-scrollShadow-finished
 */
export declare const connectScrollShadow: (els: HTMLElement | HTMLElement[]) => void;
export declare const unconnectScrollShadow: (el: HTMLElement) => void;
/**
 * Посчитать глубину скролла (процент на сколько проскроллена страница)
 *
 * @deprecated
 */
export declare const amountScrolled: () => number;
/**
 * Получить прогресс скролла в процентах
 */
export declare const getScrollPercent: (el?: HTMLElement) => number;
