import { Store } from './store';
import { App } from 'vue';
type Options = {
    onInit: (context: Context) => void;
};
type Context = {
    store: Store;
    options: object;
};
/**
 * Плагин tpa (Third-party access) для pinia
 *
 * Сейчас не используется
 *
 * TODO: Должен реализовывать возмоэности piniaTPAPlugin
 */
declare const _default: {
    install: (app: App<any>, options: Options) => void;
};
export default _default;
/**
 * Применить плагины к store
 */
export declare const usePlugins: (store: Store, options?: object) => void;
