import { Core as x } from "../core/app.js";
import { defineComponent as I, ref as C, computed as F, createElementBlock as v, openBlock as u, normalizeClass as $, createCommentVNode as k, createElementVNode as E, toDisplayString as w, createVNode as K, withKeys as L, withModifiers as M, createBlock as T, createSlots as R, withCtx as A, createTextVNode as B, watch as _, toRef as oe, mergeProps as Y, mergeModels as J, useModel as X, Fragment as P, renderList as N, withDirectives as Q, vModelRadio as te, resolveDirective as le, unref as V, renderSlot as U } from "vue";
import { w as se, _ as W, f as ae, d as ne, u as re, C as j, x as ie } from "../.chunks/forms-zDpk9gMK.es.js";
import { invertKeyboardLayout as ue } from "../utils/keyboard.js";
import { TopPopup as de, TopPopupListItem as D, TopPopupWidgetInput as pe } from "../popup/popup.js";
import { _ as ce } from "../.chunks/menu.vue_vue_type_style_index_0_lang-B5fkWPo5.es.js";
const ee = ["../assets/formsExt.css"].map((n) => import.meta.resolve(n));
x.insertCSSLinkToPage(ee, !0);
const me = { class: "top-editArea_footer" }, fe = /* @__PURE__ */ I({
  __name: "editArea",
  props: {
    defaultValue: { default: "" },
    title: {},
    cancelText: { default: "Cancel" },
    submitText: { default: "Send" },
    closeText: { default: "Close" },
    isFocused: { type: Boolean },
    forceShowCloseBtn: { type: Boolean },
    attachToKeyboard: { type: Boolean },
    modelValue: {},
    name: {},
    placeholder: {},
    styling: {},
    rows: {},
    minHeight: {},
    expandable: { type: Boolean, default: !0 },
    disabled: { type: Boolean },
    readonly: { type: Boolean },
    isError: { type: Boolean },
    hint: {}
  },
  emits: ["submit", "close", "clickOnTitle"],
  setup(n, { emit: t }) {
    const o = n, l = t, d = C(o.defaultValue), s = C(o.isFocused), m = F(() => d.value !== o.defaultValue), c = (r) => {
      l("submit", r), d.value = o.defaultValue;
    }, y = () => {
      if (o.forceShowCloseBtn && !m.value) {
        l("close");
        return;
      }
      d.value = o.defaultValue;
    }, g = () => {
      o.attachToKeyboard && l("clickOnTitle");
    };
    return (r, h) => (u(), v("div", {
      class: $({
        "top-editArea": !0,
        "top-editArea-attachedToKeyboard": r.attachToKeyboard
      })
    }, [
      r.title ? (u(), v("div", {
        key: 0,
        class: "top-editArea_title",
        onClick: h[0] || (h[0] = (i) => g())
      }, w(r.title), 1)) : k("", !0),
      E("div", {
        class: $({
          "top-editArea_form": !0,
          "top-error": r.isError,
          "top-focus": s.value
        })
      }, [
        K(se, {
          modelValue: d.value,
          "onUpdate:modelValue": h[1] || (h[1] = (i) => d.value = i),
          name: r.name,
          placeholder: r.placeholder,
          rows: r.rows,
          minHeight: r.minHeight,
          expandable: r.expandable,
          disabled: r.disabled,
          readonly: r.readonly,
          isError: r.isError,
          hint: r.hint,
          class: "top-editArea_element",
          onFocus: h[2] || (h[2] = () => s.value = !0),
          onBlur: h[3] || (h[3] = () => s.value = !1),
          onKeyup: [
            L(y, ["esc"]),
            h[4] || (h[4] = L(M((i) => c(d.value), ["ctrl"]), ["enter"]))
          ]
        }, null, 8, ["modelValue", "name", "placeholder", "rows", "minHeight", "expandable", "disabled", "readonly", "isError", "hint"]),
        E("div", me, [
          m.value || r.forceShowCloseBtn ? (u(), T(W, {
            key: 0,
            icon: r.$core.state.isMobile ? "" : "",
            class: "top-editArea_button",
            color: "theme",
            styling: "soft",
            onClick: y
          }, R({ _: 2 }, [
            r.$core.state.isMobile ? void 0 : {
              name: "default",
              fn: A(() => [
                B(w(r.cancelText), 1)
              ]),
              key: "0"
            }
          ]), 1032, ["icon"])) : k("", !0),
          m.value ? (u(), T(W, {
            key: 1,
            class: "top-editArea_button",
            icon: r.$core.state.isMobile ? "" : "",
            onClick: h[5] || (h[5] = (i) => c(d.value))
          }, R({ _: 2 }, [
            r.$core.state.isMobile ? void 0 : {
              name: "default",
              fn: A(() => [
                B(w(r.submitText), 1)
              ]),
              key: "0"
            }
          ]), 1032, ["icon"])) : k("", !0)
        ])
      ], 2)
    ], 2));
  }
}), ve = { class: "top-editInput" }, ye = /* @__PURE__ */ I({
  __name: "editInput",
  props: {
    modelValue: {},
    input: {},
    button: {}
  },
  emits: ["update:modelValue"],
  setup(n, { emit: t }) {
    const o = n, l = C(o.modelValue);
    _(oe(o.modelValue), () => {
      l.value = o.modelValue;
    });
    const d = t, s = () => {
      d("update:modelValue", l.value);
    };
    return (m, c) => (u(), v("div", ve, [
      K(ae, Y(m.input, {
        onKeydownCapture: c[0] || (c[0] = L(M((y) => l.value = m.modelValue, ["stop"]), ["esc"])),
        onKeydown: L(M(s, ["stop"]), ["enter"]),
        modelValue: l.value,
        "onUpdate:modelValue": c[1] || (c[1] = (y) => l.value = y)
      }), null, 16, ["onKeydown", "modelValue"]),
      l.value !== m.modelValue ? (u(), T(W, Y({
        key: 0,
        icon: "",
        styling: "soft"
      }, m.button, { onClick: s }), null, 16)) : k("", !0)
    ]));
  }
}), he = ["data-top-icon", "onClick"], be = {
  key: 0,
  class: "top-radioGroup_circle"
}, ge = ["value", "disabled"], ke = /* @__PURE__ */ I({
  __name: "radioGroup",
  props: /* @__PURE__ */ J({
    modelValue: {},
    radiosProps: {},
    showIndicator: { type: Boolean },
    size: { default: "s" },
    isError: { type: Boolean }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const t = X(n, "modelValue"), o = n, l = C(null);
    _(t, () => {
      var s, m, c, y, g;
      (s = o.radiosProps) != null && s.some((r) => r.value === t.value) || (t.value = ((c = (m = o.radiosProps) == null ? void 0 : m[0]) == null ? void 0 : c.value) ?? ""), (g = (y = l.value) == null ? void 0 : y.querySelector(".radioGroup_item-selected")) == null || g.scrollIntoView();
    }, { immediate: !0 });
    const d = "radioGroup-" + Math.random();
    return (s, m) => (u(), v("div", {
      ref_key: "elRef",
      ref: l,
      class: $({
        "top-radioGroup": !0,
        "top-scrollBarXHidding": !0,
        ["top-size_" + s.size]: !!s.size,
        "top-error": s.isError
      })
    }, [
      (u(!0), v(P, null, N(s.radiosProps, (c) => (u(), v("label", {
        class: $({
          "top-radioGroup_item-selected": c.value === t.value,
          "top-radioGroup_item": !0,
          "top-forms-focusable": !0,
          "top-disabled": c.disabled
        }),
        "data-top-icon": c.icon,
        onClick: (y) => t.value = c.value
      }, [
        B(w(c.title) + " ", 1),
        s.showIndicator ? (u(), v("span", be)) : k("", !0),
        Q(E("input", {
          "onUpdate:modelValue": m[0] || (m[0] = (y) => t.value = y),
          name: d,
          type: "radio",
          class: $({
            "top-unvisible": !0
          }),
          value: c.value,
          disabled: c.disabled
        }, null, 8, ge), [
          [te, t.value]
        ])
      ], 10, he))), 256))
    ], 2));
  }
}), Ve = ["data-top-icon"], Ce = ["value", "checked", "disabled", "onChange"], $e = /* @__PURE__ */ I({
  __name: "checkboxGroup",
  props: /* @__PURE__ */ J({
    modelValue: {},
    items: {},
    size: { default: "s" },
    styling: { default: "outline" },
    isError: { type: Boolean }
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const t = X(n, "modelValue"), o = (l) => {
      const d = [...t.value], s = d.indexOf(l);
      s === -1 ? d.push(l) : d.splice(s, 1), t.value = d;
    };
    return (l, d) => (u(), v("div", {
      class: $({
        "top-checkboxGroup": !0,
        ["top-checkboxGroup-" + l.styling]: !0,
        "top-scrollBarXHidding": !0,
        ["top-size_" + l.size]: !!l.size,
        "top-error": l.isError
      })
    }, [
      (u(!0), v(P, null, N(l.items, (s) => (u(), v("label", {
        key: s.id,
        class: $({
          "top-checkboxGroup_item": !0,
          "top-checkboxGroup_item-selected": t.value.includes(s.id),
          "top-forms-focusable": !0,
          "top-disabled": s.disabled
        }),
        "data-top-icon": s.icon
      }, [
        E("input", {
          type: "checkbox",
          class: "top-unvisible",
          value: s.id,
          checked: t.value.includes(s.id),
          disabled: s.disabled,
          onChange: (m) => o(s.id)
        }, null, 40, Ce),
        B(" " + w(s.title), 1)
      ], 10, Ve))), 128))
    ], 2));
  }
}), we = (n, t, o) => {
  const l = C([]), d = C(!1);
  let s = "", m;
  n && !n.params.limit && (n.params.limit = 100);
  const c = async () => {
    if (!n) return;
    let i, S;
    if (o && (n.cache ??= /* @__PURE__ */ new Map(), S = JSON.stringify(n.params), i = n.cache.get(S), i))
      return i;
    if (d.value = !0, i = await n.call(), d.value = !1, i.errors) return;
    if (!Array.isArray(i.result)) {
      console.warn("В result ожидался массив");
      return;
    }
    const z = i.result.findIndex((O) => O.id === void 0 || O.name === void 0);
    if (z !== -1) {
      console.warn(`В result[${z}] нет id или name`);
      return;
    }
    return o && n.cache.set(S, i), i;
  }, y = async () => {
    if (!n) return;
    n.params.offset = 0, n.params.search = s;
    const i = await c();
    i && (m = i.nextOffset, l.value = i.result);
  }, g = async () => {
    if (!n || !m || d.value) return;
    n.params.offset = m, n.params.search = s;
    const i = await c();
    i && (m = i.nextOffset, l.value = l.value.concat(i.result));
  }, r = ne(() => y(), 200);
  return {
    items: l,
    isLoading: d,
    loadAppend: g,
    setSearchTextAndLoad: (i, S = !0) => {
      n && (i.length < t || i === s && l.value.length || (s = i, S ? r() : y()));
    }
  };
}, Ae = { class: "top-selector2_itemMulti top-ellipsis" }, Te = /* @__PURE__ */ I({
  __name: "itemMulti",
  props: {
    id: {},
    name: {}
  },
  emits: ["delete"],
  setup(n) {
    return (t, o) => (u(), v("div", Ae, [
      B(w(t.name) + " ", 1),
      E("span", {
        class: "top-selector2_itemMultiDelete",
        "data-top-icon": "",
        onClick: o[0] || (o[0] = (l) => t.$emit("delete", t.id)),
        onMousedown: o[1] || (o[1] = M(() => {
        }, ["stop"]))
      }, null, 32)
    ]));
  }
}), Se = {
  key: 0,
  class: "top-selector2_activeItems"
}, Be = {
  key: 1,
  class: "top-selector2_activeName top-ellipsis"
}, Ie = /* @__PURE__ */ I({
  __name: "selector2",
  props: /* @__PURE__ */ J({
    modelValue: {},
    items: { default: () => [] },
    multiselect: { type: Boolean },
    disabled: { type: Boolean },
    size: { default: "s" },
    isError: { type: Boolean },
    apiRequest: {},
    minLength: { default: 0 },
    useCache: { type: Boolean },
    appendSearchToResult: { type: Boolean },
    appendAllValue: { type: Boolean },
    addChanger: { type: Boolean },
    placeholder: {},
    showSelectedInInput: { type: Boolean, default: !0 },
    showSearch: { type: Boolean, default: !0 }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const t = n, o = X(n, "modelValue"), l = C(""), d = () => {
      l.value = "", g.items.value = [];
    }, s = {
      id: 0,
      name: re().Common.All
    }, m = C(null), c = C(null), y = () => {
      var e;
      return (e = m.value) == null ? void 0 : e.popup;
    };
    window.__STORYBOOK_PREVIEW__ && !t.modelValue && _(
      () => t.multiselect,
      () => {
        o.value = t.multiselect ? [] : { id: null, name: "" };
      },
      { immediate: !0 }
    );
    const g = we(t.apiRequest, t.minLength, t.useCache), r = F(() => {
      const e = [];
      return !t.multiselect && t.appendAllValue && e.push(s), t.items.forEach((a) => e.push({ ...a })), e;
    }), h = (e, a = !0) => a && e.id === null ? Array.isArray(o.value) ? o.value.some((f) => f.id === e.id && f.name === e.name) : e.name === o.value.name : Array.isArray(o.value) ? o.value.some((f) => f.id === e.id) : e.id === o.value.id, i = F(() => {
      const e = l.value.toLowerCase(), a = ue(e);
      let f = [];
      return r.value.forEach((p) => {
        const b = p.name.toLowerCase();
        (p.id === Number(e) || b.includes(e) || b.includes(a)) && (b === e || b === a ? f.unshift(p) : f.push(p));
      }), f.push(...g.items.value), t.appendSearchToResult && l.value && (!f.length || f[0].name.toLowerCase() !== e) && f.push({
        id: null,
        name: l.value
      }), t.multiselect && (f = f.filter((p) => !h(p))), f;
    }), S = async (e) => {
      if (t.multiselect) {
        if (!Array.isArray(o.value) || h(e))
          return;
        const a = [...o.value];
        a.push({ ...e }), o.value = a, j.state.isMobile || setTimeout(() => {
          var f, p, b, H;
          (f = y()) == null || f.recalcPosition(), (H = (b = (p = y()) == null ? void 0 : p.elPopupWidget) == null ? void 0 : b.querySelector("input")) == null || H.focus(), l.value && d();
        });
      } else
        JSON.stringify(e) !== JSON.stringify(o.value) && (o.value = { ...e });
    }, z = () => {
      if (!Array.isArray(o.value)) {
        const a = (r.value.findIndex((f) => f.id === o.value.id) + 1) % r.value.length;
        o.value = { ...r.value[a] };
      }
    }, O = async (e) => {
      Array.isArray(o.value) && (o.value = o.value.filter((a) => a.id !== e), setTimeout(() => {
        var a;
        (a = y()) == null || a.recalcPosition();
      }));
    }, G = C(!1);
    t.apiRequest && (_(G, () => {
      G.value && g.setSearchTextAndLoad(l.value, !1);
    }), _(l, () => g.setSearchTextAndLoad(l.value)));
    const Z = (e) => {
      const a = e.target;
      a.scrollTop / (a.scrollHeight - a.offsetHeight) > 0.8 && g.loadAppend();
    }, q = () => {
      var e;
      G.value = !1, (e = c.value) == null || e.focus(), l.value && d();
    };
    return (e, a) => {
      const f = le("top-focus");
      return u(), T(V(de), {
        ref_key: "popupRef",
        ref: m,
        onOpen: a[3] || (a[3] = (p) => G.value = !0),
        onClose: a[4] || (a[4] = (p) => q()),
        onScrollContentList: a[5] || (a[5] = (p) => e.apiRequest ? Z(p) : void 0),
        notch: !1,
        transitionDuration: 0
      }, R({
        opener: A(() => [
          Q((u(), v("div", {
            ref_key: "elRef",
            ref: c,
            class: $({
              "top-selector2": !0,
              "top-selector2-multiselect": e.multiselect,
              ["top-size_" + e.size]: !0,
              "top-disabled": e.disabled,
              "top-forms-focusable": !e.disabled,
              "top-error": e.isError
            }),
            onKeydown: [
              a[0] || (a[0] = L(M((p) => p.currentTarget.click(), ["stop", "prevent"]), ["up", "down", "enter", "space"])),
              a[1] || (a[1] = L((p) => o.value = [], ["delete"]))
            ],
            tabindex: "0"
          }, [
            e.multiselect ? (u(), v("div", Se, [
              (u(!0), v(P, null, N(o.value, (p) => (u(), T(Te, {
                id: p.id,
                name: p.name,
                onDelete: O
              }, null, 8, ["id", "name"]))), 256))
            ])) : k("", !0),
            e.multiselect ? k("", !0) : (u(), v("span", Be, w(Array.isArray(o.value) ? "" : o.value.name), 1)),
            e.addChanger && !e.multiselect && r.value.length > 1 && !e.disabled ? (u(), v("span", {
              key: 2,
              class: "top-changer top-changer-selector",
              onClick: M(z, ["stop"])
            })) : k("", !0)
          ], 34)), [
            [
              f,
              e.isError,
              void 0,
              { onupdate: !0 }
            ]
          ])
        ]),
        contentList: A(() => {
          var p;
          return [
            (u(!0), v(P, null, N(i.value, (b) => (u(), T(V(D), {
              class: $({
                "top-active": !Array.isArray(o.value) && !e.multiselect && o.value.id === b.id && o.value.name === b.name
              }),
              key: b.id ?? void 0,
              closeByClick: !e.multiselect || V(j).state.isMobile,
              onClick: (H) => S(b)
            }, {
              default: A(() => [
                e.$slots.item ? U(e.$slots, "item", {
                  key: 0,
                  item: b
                }) : (u(), v(P, { key: 1 }, [
                  B(w(b.name), 1)
                ], 64))
              ]),
              _: 2
            }, 1032, ["class", "closeByClick", "onClick"]))), 128)),
            !V(g).isLoading.value && !i.value.length ? (u(), T(V(D), {
              key: 0,
              type: "regular"
            }, {
              default: A(() => [
                B(w(e.$i18n.Common.No_results), 1)
              ]),
              _: 1
            })) : k("", !0),
            V(g).isLoading.value && (!e.showSearch || (p = e.apiRequest) != null && p.params.offset) ? (u(), T(V(D), {
              key: 1,
              type: "regular"
            }, {
              default: A(() => [
                K(V(ie), { type: "circles" })
              ]),
              _: 1
            })) : k("", !0)
          ];
        }),
        _: 2
      }, [
        e.showSearch ? {
          name: "widget",
          fn: A(() => {
            var p;
            return [
              K(V(pe), {
                title: "Поиск",
                icon: "",
                modelValue: l.value,
                "onUpdate:modelValue": a[2] || (a[2] = (b) => l.value = b),
                isLoading: V(g).isLoading.value && !((p = e.apiRequest) != null && p.params.offset),
                placeholder: !Array.isArray(o.value) && !e.multiselect && e.showSelectedInInput ? o.value.name : e.placeholder
              }, null, 8, ["modelValue", "isLoading", "placeholder"])
            ];
          }),
          key: "0"
        } : void 0
      ]), 1536);
    };
  }
}), Ee = ["data-top-icon"], Le = { class: "top-info_text" }, Me = {
  key: 0,
  class: "top-info_value"
}, _e = /* @__PURE__ */ I({
  __name: "info",
  props: {
    icon: {},
    styling: { default: "default" },
    size: { default: "default" }
  },
  setup(n) {
    return (t, o) => (u(), v("div", {
      class: $({
        "top-info": !0,
        ["top-size_" + t.size]: !0,
        ["top-info-styling_" + t.styling]: !0
      }),
      "data-top-icon": t.icon
    }, [
      E("div", Le, [
        U(t.$slots, "default")
      ]),
      t.$slots.additional ? (u(), v("span", Me, [
        U(t.$slots, "additional")
      ])) : k("", !0)
    ], 10, Ee));
  }
}), He = fe, De = ye, Fe = ke, Re = $e, Ue = Ie, We = ce, Je = _e;
export {
  Re as TopCheckboxGroup,
  He as TopEditArea,
  De as TopEditInput,
  Je as TopInfo,
  We as TopMenu,
  Fe as TopRadioGroup,
  Ue as TopSelector2
};
//# sourceMappingURL=formsExt.js.map
