import { Core as p } from "../core/app.js";
import { defineComponent as r, createElementBlock as a, openBlock as o, normalizeClass as d, renderSlot as s, createCommentVNode as b, createElementVNode as n, Fragment as c } from "vue";
const i = ["../assets/tabs.css"].map((t) => import.meta.resolve(t));
p.insertCSSLinkToPage(i, !0);
const m = {
  class: /* @__PURE__ */ d({
    "top-tabs": !0
  })
}, u = {
  key: 0,
  class: "top-tabs_header"
}, _ = { class: "top-tabs_contents" }, h = /* @__PURE__ */ r({
  __name: "tabs",
  props: {
    id: {}
  },
  setup(t) {
    return (e, l) => (o(), a("div", m, [
      s(e.$slots, "buttons"),
      e.$slots.header ? (o(), a("div", u, [
        s(e.$slots, "header")
      ])) : b("", !0),
      n("div", _, [
        s(e.$slots, "contents")
      ])
    ]));
  }
}), f = ["id", "name", "value", "checked", "disabled"], $ = ["for"], v = /* @__PURE__ */ r({
  __name: "tab",
  props: {
    tabsId: {},
    name: {},
    title: {},
    active: { type: Boolean },
    disabled: { type: Boolean }
  },
  setup(t) {
    return (e, l) => (o(), a(c, null, [
      n("input", {
        type: "radio",
        class: "top-tabs_tabInput top-unvisible",
        id: e.tabsId + e.name,
        name: e.tabsId,
        value: e.name,
        checked: e.active,
        disabled: e.disabled
      }, null, 8, f),
      n("label", {
        class: d({
          "top-tabs_tabLabel": !0,
          "top-forms-focusable": !0,
          "top-disabled": e.disabled
        }),
        for: e.tabsId + e.name
      }, [
        s(e.$slots, "default")
      ], 10, $)
    ], 64));
  }
}), C = ["data-tabs-name"], T = /* @__PURE__ */ r({
  __name: "content",
  props: {
    name: {}
  },
  setup(t) {
    return (e, l) => (o(), a("div", {
      class: d({
        "top-tabs_content": !0
      }),
      "data-tabs-name": e.name
    }, [
      s(e.$slots, "default")
    ], 8, C));
  }
}), S = h, y = v, B = T;
export {
  S as TopTabs,
  B as TopTabsContent,
  y as TopTabsTab
};
//# sourceMappingURL=tabs.js.map
