import { Core as j } from "../core/app.js";
import { defineComponent as P, ref as R, reactive as D, computed as M, watch as O, resolveComponent as S, createBlock as V, openBlock as d, unref as x, withCtx as u, createVNode as m, createTextVNode as L, toDisplayString as v, createElementVNode as p, createElementBlock as f, Fragment as G, renderList as X, createCommentVNode as k } from "vue";
import { _ as Q, a as q } from "./page.vue_vue_type_script_setup_true_lang-C8oRGxFZ.es.js";
import { b as z } from "./utils-BPcGxQ0s.es.js";
import { genFlagLinkByCountryCode as H } from "../utils/string.js";
import { getSearcherGIcon as J, getLangLabel as K, getDeviceGIcon as W } from "../utils/searchers.js";
import { C as N } from "./forms-zDpk9gMK.es.js";
const w = ["../assets/dialog_selectorRegions.css"].map((y) => import.meta.resolve(y));
j.insertCSSLinkToPage(w, !0);
const Y = { class: "dialog_selectorRegions_header" }, Z = ["data-top-icon"], F = ["src", "alt"], ee = { class: "top-ellipsis" }, oe = { class: "dialog_selectorRegions_regionAreaName" }, te = { key: 1 }, ne = ["data-top-icon"], ue = /* @__PURE__ */ P({
  id: "selectorRegions",
  __name: "dialog_selectorRegions",
  props: {
    regions: {},
    regionsIndexes: {},
    "@update:regionsIndexes": { type: Function }
  },
  setup(y) {
    const a = y, C = z(), l = R([]), i = R(null), _ = D({
      searcher_key: -1,
      key: -1,
      name: -1
    }), b = M({
      get() {
        return l.value.every((o) => o.selected);
      },
      set(o) {
        l.value = l.value.map((n) => ({ ...n, selected: o }));
      }
    }), h = (o) => {
      _[o] = -_[o], l.value.sort((n, e) => !n[o] || !e[o] ? -1 : n[o] >= e[o] ? _[o] : -_[o]);
    }, B = () => {
      var n;
      if (!l.value.some((e) => e.selected)) return;
      const o = l.value.filter((e) => e.selected).map((e) => e.index);
      (n = a["@update:regionsIndexes"]) == null || n.call(a, o), C.close();
    };
    O([
      () => a.regions,
      () => a.regionsIndexes
    ], () => {
      if (l.value = [], !a.regions || !a.regionsIndexes) return;
      let o = [...a.regions];
      const n = new Map(a.regionsIndexes.map((e, s) => [e, s]));
      o.sort((e, s) => {
        const t = n.get(e.index) ?? Number.MAX_VALUE, r = n.get(s.index) ?? Number.MAX_VALUE;
        return t - r;
      }), o.forEach((e) => {
        var I;
        let s = e.name;
        e.areaName && (s += ` (${e.areaName})`);
        const t = ((I = a.regionsIndexes) == null ? void 0 : I.includes(e.index)) ?? !1, r = J(e.searcher_key), g = e.lang !== void 0 ? K(e.searcher_key ?? 999, e.lang) : void 0, c = e.device !== void 0 ? W(e.device) : void 0, U = e.countryCode !== void 0 ? H(e.countryCode) : void 0, E = {
          ...e,
          selected: t,
          title: s,
          searcherIcon: r,
          langLabel: g,
          deviceIcon: c,
          flagLink: U
        };
        l.value.push(E);
      });
    });
    const A = () => {
      var o;
      if (!((o = N.$) != null && o.ui.sortable)) {
        console.info("Для работы сортировки требуется глобальная загрузка jQuery UI Sortable");
        return;
      }
      i.value && $(i.value).sortable({
        distance: 10,
        stop: () => {
          const n = [...i.value.children].map((e) => Number(e.getAttribute("data-region-index")));
          l.value.sort((e, s) => n.indexOf(e.index) - n.indexOf(s.index));
        }
      });
    }, T = () => {
      var o;
      (o = N.$) != null && o.ui.sortable && i.value && $(i.value).sortable("destroy");
    };
    return (o, n) => {
      const e = S("TopCheckbox"), s = S("TopButton");
      return d(), V(x(Q), {
        id: x(C).id,
        pageActive: "selectorRegions",
        class: "dialog_selectorRegions",
        height: "600px",
        width: "600px",
        onOpen: A,
        onClose: T
      }, {
        default: u(() => [
          m(x(q), {
            name: "selectorRegions",
            order: 0
          }, {
            header: u(() => {
              var t, r, g;
              return [
                p("div", Y, [
                  m(e, {
                    modelValue: b.value,
                    "onUpdate:modelValue": n[0] || (n[0] = (c) => b.value = c)
                  }, null, 8, ["modelValue"]),
                  m(s, {
                    class: "dialog_selectorRegions_sortButton",
                    color: "theme",
                    "data-top-icon": "",
                    onClick: n[1] || (n[1] = (c) => h("searcher_key")),
                    title: (t = o.$i18n.Projects) == null ? void 0 : t.Sort_by_search_engine
                  }, null, 8, ["title"]),
                  m(s, {
                    class: "dialog_selectorRegions_sortButton",
                    color: "theme",
                    "data-top-icon": "",
                    onClick: n[2] || (n[2] = (c) => h("key")),
                    title: (r = o.$i18n.Projects) == null ? void 0 : r.Sort_by_yande_region_code
                  }, null, 8, ["title"]),
                  m(s, {
                    class: "dialog_selectorRegions_sortButton",
                    color: "theme",
                    "data-top-icon": "",
                    onClick: n[3] || (n[3] = (c) => h("name")),
                    title: (g = o.$i18n.Projects) == null ? void 0 : g.Sort_by_lphabetically
                  }, null, 8, ["title"])
                ])
              ];
            }),
            body: u(() => [
              p("div", {
                ref_key: "elRegions",
                ref: i
              }, [
                (d(!0), f(G, null, X(l.value, (t) => (d(), V(e, {
                  key: t.index,
                  modelValue: t.selected,
                  "onUpdate:modelValue": (r) => t.selected = r,
                  class: "dialog_selectorRegions_region",
                  "data-region-index": t.index
                }, {
                  default: u(() => [
                    p("div", {
                      class: "dialog_selectorRegions_regionSearcherIcon",
                      "data-top-icon": t.searcherIcon
                    }, null, 8, Z),
                    t.flagLink ? (d(), f("img", {
                      key: 0,
                      class: "top-flag",
                      src: "//topvisor.dev" + t.flagLink,
                      alt: t.countryCode
                    }, null, 8, F)) : k("", !0),
                    p("div", ee, [
                      L(v(t.name) + " ", 1),
                      p("span", oe, v(t.areaName), 1)
                    ]),
                    t.langLabel ? (d(), f("div", te, " [" + v(t.langLabel) + "] ", 1)) : k("", !0),
                    t.deviceIcon ? (d(), f("div", {
                      key: 2,
                      "data-top-icon": t.deviceIcon
                    }, null, 8, ne)) : k("", !0)
                  ]),
                  _: 2
                }, 1032, ["modelValue", "onUpdate:modelValue", "data-region-index"]))), 128))
              ], 512)
            ]),
            footer: u(() => [
              m(s, { onClick: B }, {
                default: u(() => {
                  var t;
                  return [
                    L(v((t = o.$i18n.Common) == null ? void 0 : t.Apply), 1)
                  ];
                }),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["id"]);
    };
  }
});
export {
  ue as default
};
//# sourceMappingURL=dialog_selectorRegions-Bkw1LXvI.es.js.map
