import { Core as I } from "../core/app.js";
import { defineComponent as C, onUpdated as H, createElementBlock as n, openBlock as s, Fragment as S, createElementVNode as N, renderSlot as a, ref as P, toRef as k, watch as w, onUnmounted as R, resolveDirective as T, createBlock as h, createCommentVNode as l, unref as M, withCtx as L, Teleport as E, withDirectives as $, toDisplayString as O, createVNode as U, normalizeClass as W, resolveDynamicComponent as z, mergeProps as A } from "vue";
import { e as F } from "./forms-zDpk9gMK.es.js";
import { TopPopupWorker as _ } from "../popup/worker.js";
const D = ["../assets/listItem.css"].map((i) => import.meta.resolve(i));
I.insertCSSLinkToPage(D, !0);
const j = /* @__PURE__ */ C({
  __name: "opener",
  props: {
    id: {},
    pos: { default: "3" },
    notch: { type: Boolean, default: !0 },
    openByHover: { type: Boolean },
    posBy: { default: "fixed" }
  },
  setup(i) {
    const t = i, r = t.id || Math.random() + "";
    let p;
    function y(o) {
      setTimeout(() => {
        p = o.nextElementSibling, p && d(p);
      });
    }
    H(() => {
      p && d(p);
    });
    function d(o) {
      o.dataset.topPopup = "#" + r, o.dataset.topPopupId = r, o.dataset.topPopupPos = t.pos, o.dataset.topPopupPosBy = t.posBy, o.dataset.topPopupNotch = t.notch ? "true" : "", o.dataset.topPopupOpenByHover = t.openByHover ? "true" : "";
    }
    return (o, c) => (s(), n(S, null, [
      N("template", { ref: y }),
      a(o.$slots, "default")
    ], 64));
  }
}), q = {
  key: 0,
  class: "top-popup_header"
}, G = {
  key: 0,
  class: "top-as-a closer"
}, J = {
  key: 1,
  class: "top-popup_widget"
}, K = {
  key: 2,
  class: "top-popup_content"
}, Q = {
  key: 4,
  class: "top-popup_footer"
}, X = ["href"], te = /* @__PURE__ */ C({
  __name: "popup",
  props: {
    id: { default: "" },
    class: {},
    transitionDuration: {},
    footerSupportLink: {},
    pos: { default: "3" },
    notch: { type: Boolean, default: !0 },
    openByHover: { type: Boolean },
    posBy: { default: "fixed" }
  },
  emits: ["open", "close", "scrollContentList"],
  setup(i, { expose: t, emit: r }) {
    const p = i, y = r, d = {
      popup: void 0
    };
    t(d);
    const o = p.id || "top-popup-id-" + Math.random(), c = P(null), v = P(null), f = {
      onOpen: async (e) => {
        e.elPopup && (c.value = e.elPopup), e.elPopupInner && (e.elPopupInner.innerText = "", v.value = e.elPopupInner), f.opened = !0, f.popup = e, d.popup = e, y("open", { elPopup: e.elPopup, elPopupOpener: e.el });
      },
      onClose: (e) => {
        v.value = null, f.opened = !1, f.popup = void 0, y("close", { elPopup: e.elPopup, elPopupOpener: e.el });
      },
      classRef: k(p, "class"),
      opened: !1,
      popup: void 0,
      transitionDurationRef: k(p, "transitionDuration")
    };
    return w(() => p.class, (e, u) => {
      if (!c.value) return;
      const m = (e == null ? void 0 : e.split(" ")) ?? [], b = ((u == null ? void 0 : u.split(" ")) ?? []).filter((g) => !m.includes(g));
      c.value.classList.remove(...b), c.value.classList.add(...m);
    }), _.regVueComponent(o, f), R(() => {
      _.unregVueComponent(o);
    }), (e, u) => {
      const m = T("top-scroll-shadow");
      return s(), n(S, null, [
        e.$slots.opener ? (s(), h(j, {
          key: 0,
          id: M(o),
          pos: e.pos,
          posBy: e.posBy,
          notch: e.notch,
          openByHover: e.openByHover
        }, {
          default: L(() => [
            a(e.$slots, "opener")
          ]),
          _: 3
        }, 8, ["id", "pos", "posBy", "notch", "openByHover"])) : l("", !0),
        v.value ? (s(), h(E, {
          key: 1,
          to: v.value
        }, [
          e.$slots.header || e.$core.state.isMobile ? (s(), n("div", q, [
            e.$core.state.isMobile ? (s(), n("span", G, O(e.$i18n.Common.Close), 1)) : l("", !0),
            a(e.$slots, "header")
          ])) : l("", !0),
          e.$slots.widget ? (s(), n("div", J, [
            a(e.$slots, "widget")
          ])) : l("", !0),
          e.$slots.content ? $((s(), n("div", K, [
            a(e.$slots, "content")
          ])), [
            [m]
          ]) : l("", !0),
          e.$slots.contentList ? $((s(), n("ul", {
            key: 3,
            class: "top-popup_content",
            onScroll: u[0] || (u[0] = (B) => e.$emit("scrollContentList", B))
          }, [
            a(e.$slots, "contentList")
          ], 32)), [
            [m]
          ]) : l("", !0),
          e.$slots.footer || e.footerSupportLink ? (s(), n("div", Q, [
            e.footerSupportLink ? (s(), n("a", {
              key: 0,
              class: "top-popup_footerSupportLink",
              href: e.footerSupportLink,
              target: "_blank"
            }, [
              U(F, { hint: "" })
            ], 8, X)) : l("", !0),
            a(e.$slots, "footer")
          ])) : l("", !0)
        ], 8, ["to"])) : l("", !0)
      ], 64);
    };
  }
}), se = /* @__PURE__ */ C({
  inheritAttrs: !1,
  __name: "listItem",
  props: {
    type: { default: "button" },
    closeByClick: { type: Boolean, default: !0 }
  },
  setup(i) {
    const t = i;
    return (r, p) => (s(), n("li", {
      class: W({
        "top-popup_liNoSelectable": t.type !== "button"
      })
    }, [
      (s(), h(z(r.$attrs.href ? "a" : "div"), A({
        class: {
          "top-popup_listItem": !0,
          "top-popup_listItem-button": t.type === "button",
          // оформления кнопки
          a: t.type === "button",
          // оформления кнопки, deprecated
          "top-popup_listItem-title": t.type === "title",
          "top-popup_listItem-delimiter": t.type === "delimiter",
          "top-popup-noCloser": !r.closeByClick
        }
      }, r.$attrs), {
        default: L(() => [
          a(r.$slots, "default")
        ]),
        _: 3
      }, 16, ["class"]))
    ], 2));
  }
});
export {
  te as _,
  se as a,
  j as b
};
//# sourceMappingURL=listItem.vue_vue_type_script_setup_true_lang-Di1h6iID.es.js.map
