import { Core as S } from "../core/app.js";
import { defineComponent as E, mergeModels as W, useModel as w, ref as N, onMounted as T, onUpdated as P, createElementBlock as f, openBlock as c, normalizeClass as b, createCommentVNode as K, Fragment as q, renderList as D, createBlock as Y, mergeProps as d, createSlots as y, withCtx as h, createTextVNode as g, toDisplayString as A, createVNode as $ } from "vue";
import { _ as M, b as x, C as z } from "./forms-zDpk9gMK.es.js";
const I = ["../assets/menu.css"].map((n) => import.meta.resolve(n));
S.insertCSSLinkToPage(I, !0);
const F = {
  key: 0,
  class: "top-menu_selectAll"
}, G = /* @__PURE__ */ E({
  __name: "menu",
  props: /* @__PURE__ */ W({
    modelValue: {},
    items: {},
    isMultiple: { type: Boolean },
    canBeEmptyMultiple: { type: Boolean },
    styling: { default: "default" },
    selectAllItem: {}
  }, {
    modelValue: {
      required: !0
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(n) {
    const r = n, t = w(n, "modelValue"), a = N();
    !r.isMultiple && !(typeof t.value == "string" || t.value instanceof String) && console.warn('Type check failed for prop "modelValue". Expected String: ' + typeof t.value), r.isMultiple && !Array.isArray(t.value) && console.warn('Type check failed for prop "modelValue". Expected Array: ' + typeof t.value), r.isMultiple && !r.canBeEmptyMultiple && Array.isArray(t.value) && !t.value.length && (t.value = [r.items[0].href ?? r.items[0].value]);
    const k = (e) => Array.isArray(t.value) ? t.value.includes(e.value) : e.value === t.value, C = (e, o = !1) => {
      if (Array.isArray(t.value)) {
        let l = t.value.slice();
        if (o) {
          l.length || (l = r.items.map((u) => u.value));
          const s = l.indexOf(e.value);
          s === -1 ? l.push(e.value) : l.splice(s, 1);
        } else
          l.length === 1 && l[0] === e.value ? l = [] : l = [e.value];
        !r.canBeEmptyMultiple && !l.length && (l = [e.value]), t.value = l;
        return;
      }
      t.value = e.value;
    }, L = (e) => {
      if (a.value.scrollWidth <= a.value.offsetWidth || e.shiftKey || Math.abs(e.deltaY) < 50) return;
      e.preventDefault();
      const o = e.deltaY > 0 ? 30 : -30;
      a.value.scrollLeft = a.value.scrollLeft + o;
    }, v = (e = !0) => {
      var m, p;
      const o = a.value.querySelector(".top-active");
      if (!o) return;
      const l = 24, s = o.offsetLeft - a.value.offsetLeft - l, u = o.offsetLeft - a.value.offsetLeft + o.clientWidth + l, _ = a.value.scrollLeft, B = a.value.clientWidth + a.value.scrollLeft;
      let i;
      s < _ && (i = s), u > B && (i = u - a.value.clientWidth), i !== void 0 && (x() ? (p = (m = z).$) == null || p.call(m, a.value).animate({ scrollLeft: i }, e ? 200 : 0) : a.value.scrollTo({ left: i, behavior: e ? "smooth" : "auto" }));
    }, V = () => {
      if (Array.isArray(t.value)) {
        if (t.value.length === r.items.length) {
          t.value = [r.items[0].href ?? r.items[0].value];
          return;
        }
        t.value = r.items.map((e) => e.href ?? e.value);
      }
    };
    return T(() => v(!1)), P(() => v(!0)), (e, o) => (c(), f("div", {
      ref_key: "el",
      ref: a,
      class: b({
        "top-menu": !0,
        ["top-style_" + e.styling]: !0
        // ['top-unwrap-x']: styling === 'default',
      }),
      onWheel: L
    }, [
      (c(!0), f(q, null, D(e.items, (l) => (c(), Y(M, d({ ref_for: !0 }, l, {
        class: "top-menu_item",
        color: "theme",
        onClick: (s) => C(l, s.ctrlKey || s.metaKey),
        isActive: k(l)
      }), y({ _: 2 }, [
        l.content ? {
          name: "default",
          fn: h(() => [
            g(A(l.content), 1)
          ]),
          key: "0"
        } : void 0
      ]), 1040, ["onClick", "isActive"]))), 256)),
      Array.isArray(t.value) && e.selectAllItem ? (c(), f("div", F, [
        $(M, d(e.selectAllItem, {
          class: "top-menu_item",
          color: "theme",
          styling: "",
          onClick: o[0] || (o[0] = (l) => V()),
          isActive: t.value.length === e.items.length
        }), y({ _: 2 }, [
          e.selectAllItem.content ? {
            name: "default",
            fn: h(() => [
              g(A(e.selectAllItem.content), 1)
            ]),
            key: "0"
          } : void 0
        ]), 1040, ["isActive"])
      ])) : K("", !0)
    ], 34));
  }
});
export {
  G as _
};
//# sourceMappingURL=menu.vue_vue_type_style_index_0_lang-B5fkWPo5.es.js.map
