import { Core as w } from "../core/app.js";
import { reactive as N, defineComponent as k, ref as T, computed as L, resolveComponent as z, withDirectives as D, createElementBlock as m, openBlock as r, normalizeClass as E, createElementVNode as _, createBlock as C, createCommentVNode as p, mergeProps as j, Teleport as x, Fragment as O, renderList as V, unref as A, normalizeStyle as F } from "vue";
import { C as h } from "./forms-zDpk9gMK.es.js";
import { genIntHash as J, nl2br as U } from "../utils/string.js";
const I = ["../assets/notice.css"].map((e) => import.meta.resolve(e));
w.insertCSSLinkToPage(I, !0);
const v = 300, u = N(/* @__PURE__ */ new Map()), W = (e, s, t) => "top-notice_" + J(e + s + JSON.stringify(t)), se = (e, s = "info", t) => {
  let i = "";
  e = String(e);
  const d = W(e, s, t);
  if (t != null && t.title)
    i = t.title;
  else {
    const c = e.split(`
`);
    c.length && (i = String(c.shift()), e = c.join(`
`));
  }
  const l = u.get(d);
  if (l) {
    q(l);
    return;
  }
  const a = {
    id: d,
    title: i,
    text: e,
    style: s,
    buttonProps: t == null ? void 0 : t.buttonProps,
    metaText: t == null ? void 0 : t.metaText,
    isSafeHTML: t == null ? void 0 : t.isSafeHTML,
    selectToClose: t == null ? void 0 : t.selectToClose,
    onClose: t == null ? void 0 : t.onClose
  };
  if (u.set(a.id, a), u.size > 5) {
    const [c, f] = [...u].at(0) || [];
    f && S(f);
  }
  h.state.isMobile && $("input").one("click", () => S(a));
}, q = (e) => {
  e.hightlight = !0, setTimeout(() => e.hightlight = !1, v);
}, S = (e) => {
  e.forceClosed = !0, setTimeout(() => {
    var s;
    (s = e.onClose) == null || s.call(e), u.delete(e.id);
  }, v);
}, H = (e) => {
  const s = "hacking was detected";
  return e = e.replace(/<script/g, s), e = e.replace(/<img/g, s), e = e.replace(/<iframe/g, s), e = e.replace(/javascript:/g, s), e = e.replace(/<[^>]+ (@|on)\w+=[^>]+>?/g, s), e;
}, G = { class: "top-notice_itemTextWrapper" }, K = ["innerHTML"], Q = ["innerHTML"], R = ["innerHTML"], X = ["title"], Y = /* @__PURE__ */ k({
  __name: "item",
  props: {
    id: {},
    title: {},
    text: {},
    style: {},
    metaText: {},
    buttonProps: {},
    isSafeHTML: { type: Boolean },
    hightlight: { type: Boolean },
    selectToClose: { type: Boolean, default: !0 },
    forceClosed: { type: Boolean }
  },
  emits: ["close"],
  setup(e, { emit: s }) {
    const t = e, i = s, d = T(!1);
    setTimeout(() => d.value = !0, 10);
    const l = T(!1), a = T("right"), c = L(() => {
      let o = t.title.replace(/ {2}/g, "&nbsp;");
      return t.isSafeHTML || (o = H(o)), o;
    }), f = L(() => {
      let o = U(t.text);
      return o = o.replace(/ {2}/g, "&nbsp;"), t.isSafeHTML || (o = H(o)), o;
    }), g = (o) => {
      l.value = !0, o && (a.value = o), setTimeout(() => i("close"), v);
    }, B = (o) => {
      if (!t.selectToClose) return;
      const { tagName: n } = o.target;
      n === "A" && g(), n === "BUTTON" && g();
    }, P = {
      mounted: (o) => {
        if (!h.state.isMobile || !h.$ || !h.$.ui.draggable) return;
        let n = "right";
        h.$(o).draggable({
          revert: !1,
          axis: "x",
          drag: (b, y) => {
            n = y.position.left > 0 ? "right" : "left";
          },
          stop: (b, y) => {
            g(n);
          }
        });
      }
    };
    return (o, n) => {
      const M = z("TopButton");
      return D((r(), m("div", {
        class: E(["top-notice_item", {
          ["top-notice_item-" + o.style]: !0,
          "top-notice_item-hightlight": o.hightlight,
          "top-notice_item-showed": d.value,
          "top-notice_item-closed": l.value || o.forceClosed,
          ["top-notice_item-closed_" + a.value]: l.value
        }]),
        onClick: B
      }, [
        _("div", G, [
          c.value ? (r(), m("div", {
            key: 0,
            class: "top-notice_itemTitle",
            innerHTML: c.value
          }, null, 8, K)) : p("", !0),
          f.value ? (r(), m("div", {
            key: 1,
            class: "top-notice_itemText",
            innerHTML: f.value
          }, null, 8, Q)) : p("", !0)
        ]),
        o.buttonProps ? (r(), C(M, j({
          key: 0,
          class: "top-notice_itemButton",
          size: "s"
        }, o.buttonProps, {
          title: o.buttonProps.title,
          innerHTML: o.buttonProps.default,
          onClick: n[0] || (n[0] = (b) => g())
        }), null, 16, ["title", "innerHTML"])) : p("", !0),
        o.metaText ? (r(), m("div", {
          key: 1,
          class: "top-notice_itemMetaText",
          innerHTML: o.metaText
        }, null, 8, R)) : p("", !0),
        _("div", {
          class: "top-notice_itemClose",
          "data-top-icon": "",
          title: o.$i18n.Common.Close,
          onClick: n[1] || (n[1] = () => g())
        }, null, 8, X)
      ], 2)), [
        [P]
      ]);
    };
  }
}), Z = { class: "top-notice" }, ne = /* @__PURE__ */ k({
  __name: "notice",
  setup(e) {
    const s = (t) => {
      var i;
      (i = t.onClose) == null || i.call(t), u.delete(t.id);
    };
    return (t, i) => (r(), C(x, { to: "body" }, [
      _("div", Z, [
        (r(!0), m(O, null, V(A(u), ([d, l]) => (r(), C(Y, {
          key: l.id,
          id: l.id,
          title: l.title,
          text: l.text,
          style: F(l.style),
          buttonProps: l.buttonProps,
          metaText: l.metaText,
          isSafeHTML: l.isSafeHTML,
          forceClosed: l.forceClosed,
          hightlight: l.hightlight,
          onClose: (a) => s(l)
        }, null, 8, ["id", "title", "text", "style", "buttonProps", "metaText", "isSafeHTML", "forceClosed", "hightlight", "onClose"]))), 128))
      ])
    ]));
  }
});
export {
  ne as default,
  se as show
};
//# sourceMappingURL=notice-B8hUtbou.es.js.map
