import { defineComponent as v, provide as f, onMounted as w, getCurrentInstance as b, watch as $, createElementBlock as l, openBlock as s, unref as t, normalizeStyle as u, normalizeClass as n, createElementVNode as i, renderSlot as r, computed as k, resolveDirective as D, createCommentVNode as c, createBlock as h, Teleport as g, withDirectives as T } from "vue";
import { g as _ } from "./dialogs.vue_vue_type_script_setup_true_lang-JyillkBh.es.js";
import { C } from "./forms-zDpk9gMK.es.js";
import { b as A } from "./utils-BPcGxQ0s.es.js";
const B = ["id", "data-view-page-active", "data-modal", "data-position"], q = /* @__PURE__ */ v({
  __name: "dialog",
  props: {
    id: {},
    pageActive: {},
    width: { default: "600px" },
    height: { default: "auto" },
    modal: { type: Boolean, default: !0 },
    position: {},
    historyType: { default: "push" },
    classes: {}
  },
  emits: ["open", "close"],
  setup(p) {
    const o = _(p.id);
    if (!o)
      throw new Error("TopDialog cannot be used in a template, use useTopDialog() / useAsyncTopDialog()");
    return f("dialogWorker", o), w(() => {
      var d;
      const a = b(), e = a.parent;
      if (((d = e == null ? void 0 : e.parent) == null ? void 0 : d.type.name) !== "DialogWrapper")
        throw new Error("TopDialog cannot be used in a template, use useTopDialog()");
      if (Array.isArray(e.subTree.children) && e.subTree.children.length !== 1)
        throw new Error("TopDialog can has only one root element");
      o.onMounted(e, a);
    }), $(o.isOpened, () => {
      o.isReady.value = !0;
    }, {
      flush: "post",
      once: !0
    }), (a, e) => (s(), l("div", {
      id: t(o).idAttr,
      class: n(["top-dialog", a.classes]),
      style: u({
        "--top-dialog-width": a.width,
        "--top-dialog-height": a.height
      }),
      tabindex: "-1",
      "data-view-page-active": t(o).pageActive.value,
      "data-modal": a.modal,
      "data-position": a.position
    }, [
      e[0] || (e[0] = i("div", { class: "modal-layer modal-layer-header" }, null, -1)),
      i("div", {
        class: "modal-layer modal-layer-body",
        style: u({ "min-height": a.height + "px" })
      }, null, 4),
      r(a.$slots, "default")
    ], 14, B));
  }
}), W = {
  key: 0,
  style: { display: "none" }
}, E = ["data-order", "data-view-page"], N = { class: "modal-header" }, S = { class: "top-title" }, L = { class: "buttons" }, M = ["title"], P = ["title"], z = ["data-order", "data-view-page"], F = { class: "modal-body" }, G = /* @__PURE__ */ v({
  __name: "page",
  props: {
    isLoading: { type: Boolean },
    name: {},
    order: { default: 0 },
    prevName: {},
    footerFullWith: { type: Boolean }
  },
  setup(p) {
    const m = p, o = A(), a = k(() => {
      var e;
      return {
        active: ((e = o.pageActive) == null ? void 0 : e.value) === m.name,
        "i-load-data": m.isLoading || o.isLoadingPage.value
      };
    });
    return (e, d) => {
      const y = D("top-scroll-shadow");
      return t(o).isReady.value ? (s(), l("div", W, [
        (s(), h(g, {
          to: "#" + t(o).idAttr + " .modal-layer-header",
          disabled: !t(o).needShowPage(e.name)
        }, [
          i("div", {
            "data-order": e.order,
            "data-view-page": e.name,
            class: n(a.value)
          }, [
            i("div", N, [
              i("div", S, [
                r(e.$slots, "header")
              ]),
              i("div", L, [
                r(e.$slots, "headerButtons")
              ]),
              t(C).state.isMobile && e.prevName ? (s(), l("div", {
                key: 0,
                class: "close",
                title: e.$i18n.Common.Back,
                "data-top-icon": "",
                onClick: d[0] || (d[0] = (R) => t(o).open(e.prevName))
              }, null, 8, M)) : (s(), l("div", {
                key: 1,
                class: "close",
                title: e.$i18n.Common.Close,
                "data-top-icon": "",
                "data-action": "top-dialog-close"
              }, null, 8, P))
            ])
          ], 10, E)
        ], 8, ["to", "disabled"])),
        (s(), h(g, {
          to: "#" + t(o).idAttr + " .modal-layer-body",
          disabled: !t(o).needShowPage(e.name)
        }, [
          i("div", {
            "data-order": e.order,
            "data-view-page": e.name,
            class: n(["has_scroll_container", a.value]),
            style: u({ "--top-dialog-footer-height": e.$slots.footer ? void 0 : "0px" })
          }, [
            T((s(), l("div", F, [
              r(e.$slots, "body")
            ])), [
              [y]
            ]),
            e.$slots.footer ? (s(), l("div", {
              key: 0,
              class: n(["modal-footer", {
                "modal-footer-fullWith": e.footerFullWith
              }])
            }, [
              r(e.$slots, "footer")
            ], 2)) : c("", !0)
          ], 14, z)
        ], 8, ["to", "disabled"]))
      ])) : c("", !0);
    };
  }
});
export {
  q as _,
  G as a
};
//# sourceMappingURL=page.vue_vue_type_script_setup_true_lang-C8oRGxFZ.es.js.map
