import { Component } from 'vue';
/**
 * Компонент с определением конкретного диалогового окна с использованием компонента `TopDialog`
 */
export type TopDialogComponent = Component & {
    id?: string;
};
export type AsyncDialogComponentResolveResult<T extends TopDialogComponent> = {
    default: T;
};
export type AsyncTopDialogComponentLoader<T extends TopDialogComponent> = () => Promise<AsyncDialogComponentResolveResult<T>>;
