import { MoveDirection } from './types';
import { $el } from '../../types';
export declare const TopDialogUtils: {
    updatePageVue: (dialogId: string, pageName?: string, pageNameNext?: string) => Promise<void>;
    recalcPositions: () => void;
    toViewDirty: (toViewPageName: string, moveDirection?: MoveDirection) => Promise<void>;
    toView: (viewNameOr$Dialog: $el | string, pageName?: string, args?: string[], moveDirection?: MoveDirection, callback?: Function) => Promise<void>;
    toViewPage: ($dialog: $el, pageName?: string, args?: string[], moveDirection?: MoveDirection) => Promise<void>;
    toPrevPage: ($dialog: $el) => void;
    setLoading: ($page: $el, isLoading: boolean, duration?: number) => void;
    isLoading: ($page: $el) => boolean;
    inAnimation: ($dialog: $el) => boolean;
    close: (dialogId: string) => void;
};
