import { ComponentCustomProps } from 'vue';
import { default as Avatar } from './avatar/avatar.vue';
import { default as Button } from './button/button.vue';
import { default as Checkbox } from './checkbox/checkbox.vue';
import { default as ControlLabel } from './controlLabel/controlLabel.vue';
import { default as Hint } from './hint/hint.vue';
import { default as Input } from './input/input.vue';
import { default as InputDate } from './inputDate/inputDate.vue';
import { default as InputRange } from './inputRange/inputRange.vue';
import { default as Radio } from './radio/radio.vue';
import { default as Switcher } from './switcher/switcher.vue';
import { default as Textarea } from './textarea/textarea.vue';
import { default as Select } from './select/select.vue';
import { default as Loadbar } from './loadbar/loadbar.vue';
import { default as Preloader } from './preloader/preloader.vue';
export declare const TopAvatar: typeof Avatar & ComponentCustomProps;
export declare const TopButton: typeof Button & ComponentCustomProps;
export declare const TopCheckbox: typeof Checkbox & ComponentCustomProps;
export declare const TopControlLabel: typeof ControlLabel & ComponentCustomProps;
export declare const TopHint: typeof Hint & ComponentCustomProps;
export declare const TopInput: typeof Input & ComponentCustomProps;
export declare const TopInputDate: typeof InputDate & ComponentCustomProps;
export declare const TopInputRange: typeof InputRange & ComponentCustomProps;
export declare const TopRadio: typeof Radio & ComponentCustomProps;
export declare const TopSwitcher: typeof Switcher & ComponentCustomProps;
export declare const TopTextarea: typeof Textarea & ComponentCustomProps;
export declare const TopSelect: typeof Select & ComponentCustomProps;
export declare const TopLoadbar: typeof Loadbar & ComponentCustomProps;
export declare const TopPreloader: typeof Preloader & ComponentCustomProps;
