import { Size } from '../../forms/helpers';
export interface Item {
    id: string | number;
    title: string;
    icon?: string;
    disabled?: boolean;
}
export interface Props {
    modelValue: Item['id'][];
    items: Item[];
    size?: Size;
    styling?: Style;
    isError?: boolean;
}
export declare const styling: {
    readonly outline: "outline";
    readonly borderless: "borderless";
};
export type Style = typeof styling[keyof typeof styling];
