import { Props as InputProps } from '../../forms/input/input';
import { Props as ButtonProps } from '../../forms/button/types';
export interface Props {
    modelValue: string;
    /**
     * Любые props компонента Input, за исключением modelValue
     */
    input?: Omit<InputProps, 'modelValue'>;
    /**
     * Любые props компонента Button
     */
    button?: ButtonProps;
}
export interface Emits {
    (e: 'update:modelValue', value: string): void;
}
