import { Props as ButtonProps } from '../../forms/button/types';
export interface Props {
    /**
     * Выбранные элементы меню
     */
    modelValue: number[];
    /**
     * Список кнопок со значением и текстом
     *
     * Поддерижвает все props Button
     */
    items: Item[];
    /**
     * Выводить кнопку "Выбрать все"
     */
    showSelectAllItem?: boolean;
}
export interface Item extends ButtonProps {
    value: number;
    title?: string;
    content: string;
    icon?: string;
}
