import { ComputedRef, Ref } from 'vue';
import { Props, SearcherByKey } from '../selectorRegion';
import { Options } from '../../../forms/select/select';
/**
 * Создание и управление реактивными переменными для выбора ПС
 *
 * @param props - входные props компонента
 * @param mapSearchers - Map ПС (реактивная)
 */
export declare const useSelectSearcher: (props: Props, mapSearchers: ComputedRef<SearcherByKey>) => {
    searcherKey: Ref<number, number>;
    optionBySearcherKey: ComputedRef<Options>;
};
