import { Props, Region, SearcherIndexed, Searcher } from './selectorRegion';
import { DefineComponent, ComponentOptionsMixin, PublicProps, ComponentProvideOptions } from 'vue';
type __VLS_Props = Props;
type __VLS_PublicProps = {
    modelValue: Props['modelValue'];
    'modelValueSingle'?: Props['modelValueSingle'];
} & __VLS_Props;
declare const _default: DefineComponent<__VLS_PublicProps, {
    getSearcher: () => SearcherIndexed | undefined;
    getRegion: () => Region | undefined;
}, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    "update:modelValue": (value: number[]) => any;
    "update:modelValueSingle": (value: number | undefined) => any;
}, string, PublicProps, Readonly<__VLS_PublicProps> & Readonly<{
    "onUpdate:modelValue"?: ((value: number[]) => any) | undefined;
    "onUpdate:modelValueSingle"?: ((value: number | undefined) => any) | undefined;
}>, {
    addChanger: boolean;
    searchers: Searcher[];
    addSearcherIcon: boolean;
    addRegionIcon: boolean;
}, {}, {}, {}, string, ComponentProvideOptions, false, {}, HTMLDivElement>;
export default _default;
