import { Props as TagIconProps } from '../tagIcon/types';
export interface Props extends TagIconProps {
    /**
     * Можно ли изментять тег
     */
    editable?: boolean;
    /**
     * Запретить выбор тега
     */
    disabled?: boolean;
    /**
     * Можно ли исключать
     */
    canExclude?: boolean;
}
export type Emits = {
    /**
     * Изменить имя
     */
    'update:name': [name: string];
    /**
     * Сбросить статус выбора тега
     */
    unselect: [];
    /**
     * Исключить тег
     */
    exclude: [];
    /**
     * Выбрать тег
     */
    select: [];
};
