import { Tag } from '../types';
export interface Props {
    /**
     * Индекс тега
     *
     * Определяет цвет, не зависит от порядка сортирвоки тегов
     */
    id: Tag['id'] | 'all';
    /**
     * Индекс цвета тега
     */
    colorId: '' | '1' | '2' | '3' | '4' | '5' | '6' | '7' | '8' | '9' | '10';
    /**
     * Имя тега
     */
    name: string;
    /**
     * Состояние выбора тега
     */
    state: '' | 'selected' | 'excluded';
}
