import { Props as TagSelectorOpenerProps } from '../popupOpener/types';
import { Tag, TagIdExclude } from '../types';
/**
 * Полуичить значение исключения тега tagId
 */
export declare const genTagIdExcluded: (tagId: Tag["id"]) => TagIdExclude;
/**
 * Вернуть чистый tagId без exclude флага
 */
export declare const genTagIdClear: (tagId: Tag["id"] | TagIdExclude) => "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13" | "14" | "15" | "16" | "17" | "18" | "19" | "20";
/**
 * Получить инфомрацию о теге по его id
 */
export declare const getTagById: (tagId: Tag["id"] | TagIdExclude, tags: TagSelectorOpenerProps["tags"]) => Tag | undefined;
