import { default as Core } from './core/core';
import { default as corePlugin } from './plugins/core';
import { Lang, default as i18nPlugin, useI18n, useI18nLang } from './plugins/i18n';
import { default as piniaTPAPlugin } from './plugins/piniaTPA';
export { Core, useI18n, useI18nLang, corePlugin, i18nPlugin, piniaTPAPlugin, };
export { useAsyncTopDialog, useTopDialog } from '../components/dialog/dialog/composables/utils';
export { TopDialogWorker } from '../components/dialog/lib/worker';
export type { Lang, };
