/**
 * Работа с изображениями
 * @packageDocumentation
 */
/**
 * Скачать изображение, переданное в виде строки
 * @param imageStr - адресс картинки
 * @param imageName - имя файла при загрузке, по умолчанию download
 */
export declare const downloadImageFromString: (imageStr: string, imageName?: string) => void;
/**
 * Сгенерировать html картинку с фавиконкой сайта
 * @param url - адрес сайта
 * @param isBig - если true, картинка будет 120px, иначе 32px
 */
export declare const genFaviconImgHtml: (url: string, isBig: boolean) => string;
