/**
 * Вспомогательный класс для работы с разными Поисковиками
 */
export declare const searchersNames: {
    0: string;
    20: string;
    21: string;
    1: string;
    4: string;
    5: string;
    7: string;
    8: string;
    9: string;
    101: string;
    102: string;
    103: string;
};
/**
 * Получить иконку ПС
 * @param searcherKey - цифра или строка с цифрой обозначающая ПС. Если null вернется иконка с глобусом
 */
export declare const getSearcherGIcon: (searcherKey: number | string | undefined) => string;
/**
 * Получить иконку устройства (ПК, планшет, смартфон)
 */
export declare const getDeviceGIcon: (device: number | string) => string;
/**
 * Получить иконку языка
 */
export declare const getLangLabel: (searcherKey: number | string, lang: string) => string;
/**
 * Сгенерировать заголовок типа частоты
 */
export declare const genVolumeLabel: (label: string, searcherKey: 0 | 1, volumeType: 1 | 2 | 3 | 5 | 6) => string;
/**
 * Проверить значение частоты, вернуть правильное значение частоты
 */
export declare const prepareVolumeType: (searcherKey: number, volumeType: number) => number;
