import { Core as v } from "../core/app.js";
import { defineComponent as f, ref as m, watch as y, onUnmounted as B, createElementBlock as C, openBlock as L } from "vue";
const d = ["../assets/extra.css"].map((a) => import.meta.resolve(a));
v.insertCSSLinkToPage(d, !0);
const S = /* @__PURE__ */ f({
  __name: "rive",
  props: {
    src: {},
    buffer: {},
    riveFile: {},
    artboard: {},
    animations: {},
    stateMachines: {},
    layout: {},
    autoplay: { type: Boolean, default: !0 },
    useOffscreenRenderer: { type: Boolean },
    enableRiveAssetCDN: { type: Boolean },
    shouldDisableRiveListeners: { type: Boolean },
    isTouchScrollEnabled: { type: Boolean },
    automaticallyHandleEvents: { type: Boolean },
    onLoad: {},
    onLoadError: {},
    onPlay: {},
    onPause: {},
    onStop: {},
    onLoop: {},
    onStateChange: {},
    onAdvance: {},
    assetLoader: {},
    onload: {},
    onloaderror: {},
    onplay: {},
    onpause: {},
    onstop: {},
    onloop: {},
    onstatechange: {}
  },
  setup(a, { expose: p }) {
    let t;
    const o = a, s = m(), n = {
      riveInstance: void 0
    };
    return y([s, o], async () => {
      var l;
      t || (t = await import("@rive-app/canvas-lite"));
      const e = s.value;
      if (!e) return;
      (l = n.riveInstance) == null || l.cleanup();
      const r = {
        ...o,
        canvas: e,
        onLoad: (u) => {
          var i, c;
          (i = o.onLoad) == null || i.call(o, u), (c = n.riveInstance) == null || c.resizeDrawingSurfaceToCanvas();
        }
      };
      n.riveInstance = new t.Rive(r);
    }), B(() => {
      var e;
      (e = n.riveInstance) == null || e.cleanup();
    }), p(n), (e, r) => (L(), C("canvas", {
      ref_key: "el",
      ref: s,
      class: "top-rive"
    }, null, 512));
  }
}), R = S;
export {
  R as TopRive
};
//# sourceMappingURL=extra.js.map
