import { Core as g } from "../core/app.js";
import { _ as y, a as O, b as D } from "../.chunks/listItem.vue_vue_type_script_setup_true_lang-Di1h6iID.es.js";
import { defineComponent as b, mergeModels as I, useModel as M, createBlock as B, openBlock as V, mergeProps as S, createSlots as k, withCtx as n, renderSlot as l, createVNode as c, createTextVNode as C, toDisplayString as T, ref as L, watch as w } from "vue";
import { f as H, _ as v } from "../.chunks/forms-zDpk9gMK.es.js";
const W = ["../assets/popup.css"].map((a) => import.meta.resolve(a));
g.insertCSSLinkToPage(W, !0);
const P = /* @__PURE__ */ b({
  __name: "widgetInput",
  props: /* @__PURE__ */ I({
    modelValue: {},
    name: {},
    disabled: { type: Boolean },
    readonly: { type: Boolean },
    modificator: {},
    size: {},
    styling: {},
    isError: { type: Boolean },
    isLoading: { type: Boolean },
    icon: {},
    icon2: {},
    addCleaner: { type: Boolean, default: !0 },
    title: {},
    captionType: {}
  }, {
    modelValue: {
      default: ""
    },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(a) {
    const m = M(a, "modelValue");
    return (r, e) => (V(), B(H, S(r.$props, {
      modificator: "popupWidgetInput",
      modelValue: m.value,
      "onUpdate:modelValue": e[0] || (e[0] = (s) => m.value = s)
    }), null, 16, ["modelValue"]));
  }
}), N = /* @__PURE__ */ b({
  __name: "alert",
  props: {
    submitText: {},
    id: {},
    class: {},
    transitionDuration: {},
    footerSupportLink: {},
    pos: {},
    notch: { type: Boolean },
    openByHover: { type: Boolean },
    posBy: {}
  },
  emits: ["open", "close", "scrollContentList"],
  setup(a) {
    const r = { ...a, submitText: void 0 };
    return delete r.submitText, (e, s) => (V(), B(y, S({ class: "top-popupAlert" }, r, {
      onOpen: s[0] || (s[0] = (i) => e.$emit("open", i)),
      onClose: s[1] || (s[1] = (i) => e.$emit("close", i)),
      onScrollContentList: s[2] || (s[2] = (...i) => e.$emit("scrollContentList", ...i))
    }), k({
      opener: n(() => [
        l(e.$slots, "opener")
      ]),
      footer: n(() => [
        l(e.$slots, "footer"),
        c(v, null, {
          default: n(() => [
            C(T(e.submitText || e.$i18n.Common.Close), 1)
          ]),
          _: 1
        })
      ]),
      _: 2
    }, [
      e.$slots.header ? {
        name: "header",
        fn: n(() => [
          l(e.$slots, "header")
        ]),
        key: "0"
      } : void 0,
      e.$slots.default ? {
        name: "content",
        fn: n(() => [
          l(e.$slots, "default")
        ]),
        key: "1"
      } : void 0
    ]), 1040));
  }
}), A = /* @__PURE__ */ b({
  __name: "confirm",
  props: {
    cancelText: {},
    submitText: {},
    isWarning: { type: Boolean },
    id: {},
    class: {},
    transitionDuration: {},
    footerSupportLink: {},
    pos: {},
    notch: { type: Boolean },
    openByHover: { type: Boolean },
    posBy: {}
  },
  emits: ["open", "close", "scrollContentList", "submit"],
  setup(a, { emit: m }) {
    const r = a, e = m, s = L(!1), i = () => {
      s.value = !0, e("submit");
    }, f = (t) => {
      if (s.value) {
        s.value = !1;
        return;
      }
      e("close", t);
    }, $ = { ...r, submitText: void 0, cancelText: void 0, isWarning: void 0 };
    return delete $.submitText, delete $.cancelText, delete $.isWarning, (t, p) => (V(), B(y, S({ class: "top-popupConfirm" }, $, {
      onOpen: p[0] || (p[0] = (o) => t.$emit("open", o)),
      onClose: p[1] || (p[1] = (o) => f(o)),
      onScrollContentList: p[2] || (p[2] = (...o) => t.$emit("scrollContentList", ...o))
    }), k({
      opener: n(() => [
        l(t.$slots, "opener")
      ]),
      footer: n(() => [
        l(t.$slots, "footer"),
        c(v, { color: "theme" }, {
          default: n(() => [
            C(T(t.cancelText || t.$i18n.Common.Cancel), 1)
          ]),
          _: 1
        }),
        c(v, {
          onClick: i,
          color: t.isWarning ? "red" : "blue"
        }, {
          default: n(() => [
            C(T(t.submitText || t.$i18n.Common.Continue), 1)
          ]),
          _: 1
        }, 8, ["color"])
      ]),
      _: 2
    }, [
      t.$slots.header ? {
        name: "header",
        fn: n(() => [
          l(t.$slots, "header")
        ]),
        key: "0"
      } : void 0,
      t.$slots.default ? {
        name: "content",
        fn: n(() => [
          l(t.$slots, "default")
        ]),
        key: "1"
      } : void 0
    ]), 1040));
  }
}), U = /* @__PURE__ */ b({
  __name: "prompt",
  props: {
    submitText: {},
    cancelText: {},
    defaultValue: {},
    id: {},
    class: {},
    transitionDuration: {},
    footerSupportLink: {},
    pos: {},
    notch: { type: Boolean },
    openByHover: { type: Boolean },
    posBy: {}
  },
  emits: ["open", "close", "scrollContentList", "submit"],
  setup(a, { emit: m }) {
    const r = a, e = m, s = () => f.value = r.defaultValue ?? "", i = L(!1), f = L();
    w(() => r.defaultValue, () => s(), { immediate: !0 });
    const $ = () => {
      i.value = !0;
    }, t = (o) => {
      if (i.value) {
        i.value = !1, e("submit", f.value), s();
        return;
      }
      s(), e("close", o);
    }, p = { ...r, submitText: void 0, cancelText: void 0, defaultValue: void 0 };
    return delete p.submitText, delete p.cancelText, delete p.defaultValue, (o, u) => (V(), B(y, S({ class: "top-popupPrompt" }, p, {
      onOpen: u[1] || (u[1] = (d) => o.$emit("open", d)),
      onClose: u[2] || (u[2] = (d) => t(d)),
      onScrollContentList: u[3] || (u[3] = (...d) => o.$emit("scrollContentList", ...d))
    }), k({
      opener: n(() => [
        l(o.$slots, "opener")
      ]),
      footer: n(() => [
        l(o.$slots, "footer"),
        c(v, { color: "theme" }, {
          default: n(() => [
            C(T(o.cancelText || o.$i18n.Common.Cancel), 1)
          ]),
          _: 1
        }),
        c(v, { onClick: $ }, {
          default: n(() => [
            C(T(o.submitText || o.$i18n.Common.OK), 1)
          ]),
          _: 1
        })
      ]),
      _: 2
    }, [
      o.$slots.header ? {
        name: "header",
        fn: n(() => [
          l(o.$slots, "header")
        ]),
        key: "0"
      } : void 0,
      o.$slots.default ? {
        name: "content",
        fn: n(() => [
          l(o.$slots, "default"),
          c(P, {
            modelValue: f.value,
            "onUpdate:modelValue": u[0] || (u[0] = (d) => f.value = d),
            modelModifiers: { trim: !0 }
          }, null, 8, ["modelValue"])
        ]),
        key: "1"
      } : void 0
    ]), 1040));
  }
}), q = y, F = D, G = O, J = P, Q = N, R = A, X = U;
export {
  q as TopPopup,
  Q as TopPopupAlert,
  R as TopPopupConfirm,
  G as TopPopupListItem,
  F as TopPopupOpener,
  X as TopPopupPrompt,
  J as TopPopupWidgetInput
};
//# sourceMappingURL=popup.js.map
