import { Core as U } from "../core/app.js";
import { watch as k, computed as I, ref as f, defineComponent as M, createBlock as m, openBlock as l, resolveDynamicComponent as O, normalizeClass as w, unref as i, withCtx as b, renderSlot as v, createElementBlock as d, createCommentVNode as y, mergeModels as z, useModel as D, useSlots as G, onMounted as Q, onUnmounted as H, createElementVNode as S, toDisplayString as R, Fragment as X, createTextVNode as Y, markRaw as Z, createVNode as x, KeepAlive as ee } from "vue";
import { C as $, v as te, t as oe } from "../.chunks/forms-zDpk9gMK.es.js";
import { getHash as K, genHash as ae, setHash as se, delHash as ne } from "../utils/route.js";
import { u as ie, d as re } from "../.chunks/store-CX_6ZXhO.es.js";
import { TopPopupListItem as A, TopPopup as le } from "../popup/popup.js";
import { sleepWhile as ue } from "../utils/system.js";
const q = ["../assets/tabsView.css"].map((t) => import.meta.resolve(t));
U.insertCSSLinkToPage(q, !0);
const j = (t, o) => `top:${String(t)}:${o}`, ce = (t, o) => {
  if (!o.$id) return;
  const e = j(t, o.$id);
  try {
    const a = JSON.parse(localStorage.getItem(e));
    typeof a == typeof o[t] && (o[t] = a);
  } catch {
    console.warn(new Error(`В localStorage[${e}] не корректный json`));
  }
}, pe = (t, o) => {
  if (!o.$id) return;
  const e = j(t, o.$id);
  k(() => o[t], () => {
    localStorage.setItem(e, JSON.stringify(o[t]));
  }, { immediate: !0 });
}, E = {
  loadLocalStorge: ce,
  addSaverLocalStorge: pe
}, F = /* @__PURE__ */ new Set();
addEventListener("popstate", (t) => {
  F.forEach((o) => o(t));
});
const W = Symbol(), de = (t, o) => {
  const e = re(W, () => {
    const a = I(() => t.showMenuInPopup ?? $.state.isMobile), u = I(() => t.pageMod), p = f(!1), n = f(void 0), r = f(!0);
    return {
      showMenuInPopup: a,
      pageMod: u,
      isShort: p,
      activeItemName: o,
      component: n,
      scrollable: r
    };
  }, t.idState);
  if (t.isShortable) {
    const a = "isShort";
    E.loadLocalStorge(a, e), E.addSaverLocalStorge(a, e);
  }
  if (e.$id) {
    const a = (u) => {
      o.value = K(e.$id);
    };
    F.add(a);
  }
  return e;
}, L = () => ie(W), me = {
  key: 1,
  class: "top-ellipsis"
}, g = /* @__PURE__ */ M({
  __name: "menuItem",
  props: {
    name: {},
    href: {},
    icon: {},
    disabled: { type: Boolean },
    component: { default: void 0 },
    scrollable: { type: Boolean, default: !0 }
  },
  setup(t) {
    const o = t, e = L(), a = I(() => o.name && e.$id ? ae(e.$id, o.name) : o.href), u = I(() => e.showMenuInPopup ? A : a ? "a" : "button"), p = (n) => {
      !o.href && a.value && n.preventDefault(), o.name && (e.activeItemName = o.name);
    };
    return (n, r) => (l(), m(O(u.value), {
      target: "_self",
      class: w({
        "top-tabsView_menuItem": !i(e).showMenuInPopup,
        "top-active": n.name && i(e).activeItemName === n.name,
        "top-disabled": n.disabled,
        "top-spa-disabled": !0
      }),
      href: a.value,
      "data-top-icon": n.icon || void 0,
      disabled: n.disabled || void 0,
      onClick: p
    }, {
      default: b(() => [
        i(e).showMenuInPopup ? v(n.$slots, "default", { key: 0 }) : n.$slots.default && !i(e).isShort ? (l(), d("span", me, [
          v(n.$slots, "default")
        ])) : y("", !0)
      ]),
      _: 3
    }, 8, ["class", "href", "data-top-icon", "disabled"]));
  }
}), J = (t) => (t == null ? void 0 : t.name) === "AsyncComponentWrapper" && !(t != null && t.__asyncResolved), fe = async (t, o) => {
  (t == null ? void 0 : t.name) === "AsyncComponentWrapper" && (t != null && t.__asyncResolved || (t.__asyncLoader(), await ue(() => o() && J(t), 200)));
}, ve = { class: "top-tabsView_menuOpener" }, _e = ["data-top-icon"], he = { class: "top-ellipsis" }, be = { class: "top-tabsView_menuList" }, Se = {
  key: 0,
  class: "top-tabsView_menuFooter"
}, ge = /* @__PURE__ */ M({
  __name: "menu",
  props: /* @__PURE__ */ z({
    isShortable: { type: Boolean },
    isLoading: { type: Boolean }
  }, {
    isLoading: {},
    isLoadingModifiers: {}
  }),
  emits: ["update:isLoading"],
  setup(t) {
    const o = D(t, "isLoading"), e = L(), a = G(), u = /* @__PURE__ */ new Map(), p = () => {
      if (!a.default) return;
      const c = a.default({}).find((s) => s.key === "_menu");
      c && n(c.children);
    }, n = (c) => {
      c.forEach((s) => {
        var P, T, B, C;
        if (s.type.__name && s.type.__name !== g.__name) return;
        if (!s.type.__name && typeof s.children == "object") {
          n(s.children);
          return;
        }
        if (!((P = s.props) != null && P.name) || (T = s.props) != null && T.disabled) return;
        const N = {
          title: ((C = (B = s.children).default) == null ? void 0 : C.call(B)[0].children).trim(),
          icon: s.props.icon,
          component: s.props.component ? Z(s.props.component) : g.props.component.default,
          scrollable: s.props.scrollable ?? g.props.scrollable.default
        };
        u.set(s.props.name, N);
      });
    }, r = f(null);
    let _ = 0;
    k(
      () => e.activeItemName,
      async () => {
        const c = ++_;
        if (u.size === 0 && p(), u.size === 0) {
          e.activeItemName = "";
          return;
        }
        if (r.value = u.get(e.activeItemName) ?? null, !r.value && e.$id) {
          const s = K(e.$id);
          if (r.value = u.get(s) ?? null, r.value) {
            e.activeItemName = s;
            return;
          }
        }
        if (!r.value) {
          e.activeItemName = u.keys().next().value;
          return;
        }
        if (r.value.component === e.component) {
          o.value = !1;
          return;
        }
        e.$id && se(e.$id, e.activeItemName, !1), o.value = !0, await fe(r.value.component, () => c === _), c === _ && (e.scrollable = r.value.scrollable, e.component = r.value.component, r.value && !e.component && console.warn(`Компонент вкладки ${e.activeItemName} не найден. Добавьте props.component для пункта меню ${e.activeItemName}.`));
      },
      { immediate: !0 }
    );
    const h = f();
    let V;
    return Q(() => {
      V = new ResizeObserver(() => {
        h.value.parentElement.style.setProperty("--top-tabsView-contents-offset-top", h.value.offsetHeight + "px");
      }), V.observe(h.value);
    }), H(() => {
      V.disconnect();
    }), (c, s) => (l(), d("div", {
      ref_key: "elRef",
      ref: h,
      class: w({
        "top-tabsView_menu": !0,
        "top-tabsView_menu-inPopup_0": !i(e).showMenuInPopup,
        "top-tabsView_menu-inPopup_1": i(e).showMenuInPopup,
        "top-tabsView_menu-short": i(e).isShort && !i(e).showMenuInPopup
      })
    }, [
      i(e).showMenuInPopup ? (l(), m(i(le), { key: 0 }, {
        opener: b(() => [
          S("div", ve, [
            r.value ? (l(), d("div", {
              key: 0,
              class: "top-tabsView_menuOpenerActiveItem",
              "data-top-icon": r.value.icon
            }, [
              S("span", he, R(r.value.title), 1)
            ], 8, _e)) : y("", !0),
            s[1] || (s[1] = S("div", {
              class: "top-tabsView_menuOpenerIcon",
              "data-top-icon": ""
            }, null, -1))
          ])
        ]),
        contentList: b(() => [
          v(c.$slots, "default")
        ]),
        _: 3
      })) : (l(), d(X, { key: 1 }, [
        S("div", be, [
          v(c.$slots, "default")
        ]),
        c.isShortable ? (l(), d("div", Se, [
          c.isShortable ? (l(), m(g, {
            key: 0,
            icon: i(e).isShort ? "" : "",
            onClick: s[0] || (s[0] = (N) => i(e).isShort = !i(e).isShort)
          }, {
            default: b(() => [
              Y(R(i(e).isShort ? "" : "Свернуть"), 1)
            ]),
            _: 1
          }, 8, ["icon"])) : y("", !0)
        ])) : y("", !0)
      ], 64))
    ], 2));
  }
}), ye = /* @__PURE__ */ M({
  __name: "tabsView",
  props: /* @__PURE__ */ z({
    modelValue: {},
    pageMod: { type: Boolean },
    showMenuInPopup: { type: Boolean, default: void 0 },
    isShortable: { type: Boolean, default: !1 },
    idState: {}
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(t) {
    const o = t, e = D(t, "modelValue"), a = de(o, e), u = Math.random();
    o.pageMod && $.state.documentClassModificators.set(u, "top-hasTabsViewPageMod"), H(() => {
      o.pageMod && $.state.documentClassModificators.delete(u), a.$id && ne(a.$id, a.activeItemName, !0);
    });
    const p = f(), n = f(!1);
    return k([p, () => a.component], () => {
      n.value = J(a.component);
    }, { immediate: !0 }), (r, _) => (l(), d("div", {
      class: w({
        "top-tabsView": !0,
        "top-tabsView-pageMod": o.pageMod,
        "top-tabsView-inPopup": i(a).showMenuInPopup
      })
    }, [
      x(ge, {
        isShortable: r.isShortable,
        isLoading: n.value,
        "onUpdate:isLoading": _[0] || (_[0] = (h) => n.value = h)
      }, {
        default: b(() => [
          v(r.$slots, "menu")
        ]),
        _: 3
      }, 8, ["isShortable", "isLoading"]),
      S("div", {
        class: w({
          "top-tabsView_contents": !0,
          "top-tabsView_contents-isLoading": n.value,
          "top-tabsView_contents-noScrollable": !i(a).scrollable
        })
      }, [
        n.value ? (l(), m(te, { key: 0 })) : y("", !0),
        (l(), m(ee, null, [
          (l(), m(O(i(a).component), {
            ref_key: "componentRef",
            ref: p
          }, null, 512))
        ], 1024))
      ], 2)
    ], 2));
  }
}), we = {}, Ie = { class: "top-tabsView_menuDelimeter" };
function Me(t, o) {
  return l(), d("div", Ie);
}
const Ve = /* @__PURE__ */ oe(we, [["render", Me]]), $e = /* @__PURE__ */ M({
  __name: "menuTitle",
  props: {
    isSubtitle: { type: Boolean }
  },
  setup(t) {
    const o = L();
    return (e, a) => i(o).showMenuInPopup ? (l(), m(i(A), {
      key: 0,
      type: "title"
    }, {
      default: b(() => [
        v(e.$slots, "default")
      ]),
      _: 3
    })) : i(o).isShort ? (l(), m(Ve, { key: 1 })) : (l(), d("div", {
      key: 2,
      class: w({
        "top-tabsView_menuTitle": !0,
        "top-tabsView_menuTitle-subtitle": e.isSubtitle
      })
    }, [
      v(e.$slots, "default")
    ], 2));
  }
}), Re = ye, Ee = g, Oe = $e;
export {
  Re as TopTabsView,
  Ee as TopTabsViewMenuItem,
  Oe as TopTabsViewMenuTitle
};
//# sourceMappingURL=tabsView.js.map
